$(function() {
    function calibrationcompanionViewModel_temp(parameters) {
        var self = this;

        self.settingsViewModel = parameters[0];
        self.calibrationcompanionViewModel = parameters[1];

        let mainViewModel = self.calibrationcompanionViewModel;

        self.profile_selection_temp = ko.observable();
        self.first_layer_nozzle_temp = ko.observable();
        self.regular_bed_temp = ko.observable();
        self.fan_speed_temp = ko.observable();
        self.fan_layer_temp = ko.observable();
        self.first_layer_speed_temp = ko.observable();
        self.regular_speed_temp = ko.observable();
        self.travel_speed_temp = ko.observable();
        self.retraction_dist_temp = ko.observable();
        self.retraction_speed_temp = ko.observable();
        self.flow_temp = ko.observable();
        self.abl_method_temp = ko.observable();
        self.start_gcode_temp = ko.observable();
        self.end_gcode_temp = ko.observable();

        let myParent;
        let myBase = [];
        let inputListTemp = [];
        let stageImageTemp = [];
        let layerHeightTemp = [];
        let spanControlGroup = [];
        let spanControlGroupBox = [];
        let spanControl = [];
        let spanInputAppend = [];
        let spanAddon = [];

        const stageHeightTemp = 6; //(mm)

        let t = 0;

        self.onBeforeBinding = function () {
            self.profile_selection_temp(self.settingsViewModel.settings.plugins.calibrationcompanion.profile_selection_temp());
            self.first_layer_nozzle_temp(self.settingsViewModel.settings.plugins.calibrationcompanion.first_layer_nozzle_temp());
            self.regular_bed_temp(self.settingsViewModel.settings.plugins.calibrationcompanion.regular_bed_temp());
            self.fan_speed_temp(self.settingsViewModel.settings.plugins.calibrationcompanion.fan_speed_temp());
            self.fan_layer_temp(self.settingsViewModel.settings.plugins.calibrationcompanion.fan_layer_temp());
            self.first_layer_speed_temp(self.settingsViewModel.settings.plugins.calibrationcompanion.first_layer_speed_temp());
            self.regular_speed_temp(self.settingsViewModel.settings.plugins.calibrationcompanion.regular_speed_temp());
            self.travel_speed_temp(self.settingsViewModel.settings.plugins.calibrationcompanion.travel_speed_temp());
            self.retraction_dist_temp(self.settingsViewModel.settings.plugins.calibrationcompanion.retraction_dist_temp());
            self.retraction_speed_temp(self.settingsViewModel.settings.plugins.calibrationcompanion.retraction_speed_temp());
            self.flow_temp(self.settingsViewModel.settings.plugins.calibrationcompanion.flow_temp());
            self.abl_method_temp(self.settingsViewModel.settings.plugins.calibrationcompanion.abl_method_temp());
            self.start_gcode_temp(self.settingsViewModel.settings.plugins.calibrationcompanion.start_gcode_temp());
            self.end_gcode_temp(self.settingsViewModel.settings.plugins.calibrationcompanion.end_gcode_temp());
        }

        self.onAfterBinding = function () {
            mainViewModel.spanValTemp = 0;
        }

        self.addTemp = function() {
            if (mainViewModel.variable.bed_size_z > mainViewModel.spanValTemp * (mainViewModel.variable.nozzle_size/2)) {
                t++;
                myParent = document.getElementById("tempStage");

                myBase[t] = document.createElement("div");
                myBase[t].id = "myBase" + t;
                myBase[t].className = "baseText"

                myParent.appendChild(myBase[t]);
                myBase[t].append("Stage " + t)

                myBase[t].appendChild(mainViewModel.whitespace.cloneNode())
                myBase[t].appendChild(mainViewModel.whitespace.cloneNode())

                spanControlGroupBox[t] = document.createElement("span");
                spanControlGroupBox[t].className = "control-box-temp"

                myBase[t].appendChild(spanControlGroupBox[t])

                spanControlGroup[t] = document.createElement("span");
                spanControlGroup[t].className = "control-group";
                spanControlGroupBox[t].appendChild(spanControlGroup[t])

                spanControl[t] = document.createElement("span");
                spanControl[t].className = "controls";
                spanControlGroup[t].appendChild(spanControl[t])

                spanInputAppend[t] = document.createElement("span");
                spanInputAppend[t].className = "input-append";
                spanControl[t].appendChild(spanInputAppend[t])

                inputListTemp[t] = document.createElement("input");
                inputListTemp[t].type = "text";
                inputListTemp[t].id = "inputListTemp" + t;
                inputListTemp[t].value = 200;
                inputListTemp[t].className = "midsizeTextbox";
                spanInputAppend[t].appendChild(inputListTemp[t]);

                spanAddon[t] = document.createElement("span");
                spanAddon[t].className = "add-on";
                spanAddon[t].textContent = "°C";

                spanInputAppend[t].appendChild(spanAddon[t]);

                myBase[t].appendChild(mainViewModel.whitespace.cloneNode())
                myBase[t].appendChild(mainViewModel.whitespace.cloneNode())
                myBase[t].appendChild(mainViewModel.whitespace.cloneNode())
                myBase[t].appendChild(mainViewModel.whitespace.cloneNode())

                stageImageTemp[t] = document.createElement("img");
                stageImageTemp[t].src = "/plugin/calibrationcompanion/static/images/tempStage.jpg";
                stageImageTemp[t].alt = "Temperature tower stage";
                myBase[t].appendChild(stageImageTemp[t]);

                layerHeightTemp[t] = document.createElement("span");
                layerHeightTemp[t].className = "layerHeightTemp";
                layerHeightTemp[t].textContent = mainViewModel.spanValTemp + 1;
                myBase[t].appendChild(layerHeightTemp[t]);
                mainViewModel.spanValTemp =  Math.ceil(mainViewModel.spanValTemp + stageHeightTemp / (mainViewModel.variable.nozzle_size / 2));

                myParent.insertBefore(myBase[t], myBase[t - 1]);
            }
            else {
                mainViewModel.zHeightWarning();
            }
        }
        mainViewModel.removeTemp = function() {
            if (Math.sign(t) === 1) {
                mainViewModel.spanValTemp = Math.round(mainViewModel.spanValTemp - stageHeightTemp / (mainViewModel.variable.nozzle_size / 2));
                myBase[t].remove();
                t = t-1;
            } else {
                mainViewModel.spanValTemp = 0;
                t = 0;
            }
        }

        mainViewModel.resetTemp = function() {
            while(t>0) {
                self.removeTemp()
            }
            mainViewModel.spanValTemp = 0;
        }

        $(document).on("input", function(e) {
            let id = e.target.id;
            let element = e.target;
            if (id.includes("inputListTemp")) {
                mainViewModel.checkValue(element, element.parentNode.parentNode, mainViewModel.allowedArrayClassic);
            }
        });

        let restrictedInputsTemp = ["#first-layer-nozzle-temp", "#regular-bed-temp", "#fan-speed-temp", "#fan-layer-temp", "#first-layer-speed-temp",
            "#regular-speed-temp", "#travel-speed-temp", "#retraction-dist-temp", "#retraction-speed-temp", "#flow-temp", "#abl-method-temp", "#start-gcode-temp"];
        let saveInputsTemp = ["first_layer_nozzle_temp", "regular_bed_temp", "fan_speed_temp", "fan_layer_temp", "first_layer_speed_temp",
            "regular_speed_temp", "travel_speed_temp", "retraction_dist_temp", "retraction_speed_temp", "flow_temp", "abl_method_temp", "start_gcode_temp"];

        $(restrictedInputsTemp.join(",")).on("input", function() {
            let saveSettingsTemp = saveInputsTemp[restrictedInputsTemp.indexOf('#' + this.id)]
            OctoPrint.settings.savePluginSettings('calibrationcompanion', {
                [saveSettingsTemp]: this.value})
        });

        let restrictedInputsProfile = ["abl-method-temp", "end-gcode-temp", "fan-layer-temp", "fan-speed-temp", "first-layer-nozzle-temp",
            "first-layer-speed-temp", "flow-temp", "regular-bed-temp", "novalue", "regular-speed-temp", "retraction-dist-temp",
            "retraction-speed-temp", "start-gcode-temp", "travel-speed-temp"];
        let restrictedSettingsProfile = ["abl_method", "end_gcode", "fan_layer", "fan_speed", "first_layer_nozzle",
            "first_layer_speed", "flow", "regular_bed", "novalue", "regular_speed", "retraction_dist",
            "retraction_speed", "start_gcode", "travel_speed"];
        let saveSettingsProfile, saveSettingsTextbox;

        document.getElementById("load-profile-temp").onclick = function() {
            OctoPrint.settings.getPluginSettings('calibrationcompanion').done(function (response) {
                let z = 0;
                for (let x=0; x< Object.keys(response).length; x++) {
                    if (self.profile_selection_temp()!=="" && restrictedSettingsProfile[z]!==undefined && Object.keys(response)[x].includes(self.profile_selection_temp()) && restrictedSettingsProfile[z]!=="novalue") {
                        saveSettingsProfile = restrictedSettingsProfile[z] + "_" + self.profile_selection_temp();
                        saveSettingsTextbox = restrictedSettingsProfile[z] + "_temp";
                        document.getElementById(restrictedInputsProfile[z]).value = Object.values(response)[x];
                        OctoPrint.settings.savePluginSettings('calibrationcompanion', {[saveSettingsTextbox]: Object.values(response)[x]});
                        z++;
                    } else if (self.profile_selection_temp()!=="" && restrictedSettingsProfile[z]!==undefined && Object.keys(response)[x].includes(self.profile_selection_temp()) && restrictedSettingsProfile[z] === "novalue") {
                        saveSettingsProfile = restrictedSettingsProfile[z] + "_" + self.profile_selection_temp();
                        z++;
                    }
                }
            });
        }

        let GStatus, layerStatus, EStatus;
        let relative_pos_x, relative_pos_y, relative_pos_z;
        let gcode_generated = [];
        let pos_x = [];
        let pos_y = [];
        let pos_z = [];
        let first_x_pos, first_y_pos;

        let returningPosX;
        let returningPosY;
        let first_x_absolute_pos, first_y_absolute_pos;

        let startFeedRate = [];
        let startZHeight = [];

        let printing_speed, l, start_gcode, end_gcode;
        document.getElementById("temp-tower").onclick = function () {
            if (t === 0) {
                mainViewModel.noStageMessage()
                return;
            }
            let array = [];
            let el = document.getElementById("temperature").getElementsByClassName("control-group");
            for (let x=0; x<el.length; x++) {
                array[x] = el[x].attributes[0].nodeValue;
                if (array[x].includes("error")) {
                    mainViewModel.errorMessage()
                    return
                }
            }
            mainViewModel.flowCube = false
            l = 0;
            mainViewModel.last_feed_rate = 0;
            start_gcode = document.getElementById("start-gcode-temp").value;
            end_gcode = document.getElementById("end-gcode-temp").value;
            mainViewModel.first_layer_nozzle = document.getElementById("inputListTemp1").value;
            mainViewModel.regular_nozzle = mainViewModel.first_layer_nozzle;
            mainViewModel.regular_bed = document.getElementById("regular-bed-temp").value;
            mainViewModel.fan_speed = document.getElementById("fan-speed-temp").value;
            mainViewModel.fan_layer = document.getElementById("fan-layer-temp").value;
            mainViewModel.first_layer_speed = document.getElementById("first-layer-speed-temp").value * 60;
            mainViewModel.regular_speed = document.getElementById("regular-speed-temp").value * 60;
            mainViewModel.travel_speed = document.getElementById("travel-speed-temp").value * 60;
            mainViewModel.retraction_distance = document.getElementById("retraction-dist-temp").value;
            mainViewModel.retraction_speed = document.getElementById("retraction-speed-temp").value * 60;
            mainViewModel.flow = document.getElementById("flow-temp").value;
            mainViewModel.abl_method = document.getElementById("abl-method-temp").value;
            mainViewModel.filename = "temp_tower";
            for (let s = 1; s <= t; s++) {
                let boolean = [true]
                mainViewModel.first_x_pos = String(mainViewModel.bed_center_x - 40 / 2 + 8 / 2);
                mainViewModel.first_y_pos = String(mainViewModel.bed_center_y + 8 / 2);
                mainViewModel.first_z_pos = String((mainViewModel.variable.nozzle_size/2)*l);
                first_x_absolute_pos = mainViewModel.first_x_pos;
                first_y_absolute_pos = mainViewModel.first_y_pos;
                startZHeight[s] = parseFloat(mainViewModel.zLastAbsolute) + parseFloat(mainViewModel.variable.nozzle_size)/2
                startFeedRate[s] = mainViewModel.feed_rate
                tempTowerCoord(parseFloat(mainViewModel.variable.nozzle_size));
                for (let z = 0; z<=relative_pos_x.length; z++) {
                    if (mainViewModel.variable.relative_positioning) {
                        pos_x[z] = relative_pos_x[z]
                        pos_y[z] = relative_pos_y[z]
                        pos_z[z] = relative_pos_z[z]
                    } else {
                        mainViewModel.getAbsoluteCoordinate(relative_pos_x[z], relative_pos_y[z], relative_pos_z[z], boolean[z])
                        pos_x[z] = mainViewModel.xAbsolute[z]
                        pos_y[z] = mainViewModel.yAbsolute[z]
                        pos_z[z] = mainViewModel.zAbsolute[z]
                    }
                }
                if (mainViewModel.variable.relative_positioning) {
                    returningPosX = mainViewModel.getReturningPosition(relative_pos_x);
                    returningPosY = mainViewModel.getReturningPosition(relative_pos_y);
                } else {
                    pos_x.splice(0, 1);
                    pos_y.splice(0, 1);
                    pos_z.splice(0, 1);
                    returningPosX = (parseFloat(pos_x[pos_x.length - 1]) + mainViewModel.getReturningPosition(relative_pos_x)).toFixed(3);
                    returningPosY = (parseFloat(pos_y[pos_y.length - 1]) + mainViewModel.getReturningPosition(relative_pos_y)).toFixed(3);
                    mainViewModel.first_x_pos = returningPosX
                    mainViewModel.first_y_pos = returningPosY
                    mainViewModel.first_z_pos = (mainViewModel.variable.nozzle_size/2)*l
                }
                gcode_generated[s] = [];
                for (let x = 0; x < relative_pos_x.length; x++) {
                    if (l <= 1) {
                        printing_speed = mainViewModel.first_layer_speed;
                    } else {
                        printing_speed = mainViewModel.regular_speed;
                    }
                    if (GStatus[x] !== "null") {
                        if (pos_z[x] === "null") {
                            if (GStatus[x] === "G0") {
                                gcode_generated[s][x] = GStatus[x] + " F" + mainViewModel.travel_speed + " X" + pos_x[x] + " Y" + pos_y[x] + ";\n";
                            } else {
                                if (EStatus[x] !== "null") {
                                    if (mainViewModel.variable.relative_positioning) {
                                        if (EStatus[x] === "retract") {
                                            gcode_generated[s][x] = "G1 F" + mainViewModel.retraction_speed + " E-" + mainViewModel.retraction_distance + ";\n";
                                        } else if (EStatus[x] === "extrude") {
                                            gcode_generated[s][x] = "G1 F" + mainViewModel.retraction_speed + "E" + mainViewModel.retraction_distance + ";\n";
                                        }
                                    } else {
                                        if (EStatus[x] === "retract") {
                                            gcode_generated[s][x] = "G1 F" + mainViewModel.retraction_speed + " E" + (mainViewModel.feed_rate - mainViewModel.retraction_distance).toFixed(5) + ";\n";
                                        } else if (EStatus[x] === "extrude") {
                                            gcode_generated[s][x] = "G1 F" + mainViewModel.retraction_speed + " E" + mainViewModel.feed_rate + ";\n";
                                        }
                                    }
                                } else {
                                    mainViewModel.extruded_length_calculation_relative(relative_pos_x[x], relative_pos_y[x])
                                    gcode_generated[s][x] = GStatus[x] + " F" + printing_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " E" + mainViewModel.feed_rate + ";\n";
                                }
                            }
                        } else {
                            if (GStatus[x] === "G0") {
                                gcode_generated[s][x] = GStatus[x] + " F" + mainViewModel.travel_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " Z" + pos_z[x] + ";\n";
                            } else {
                                mainViewModel.extruded_length_calculation_relative(relative_pos_x[x], relative_pos_y[x])
                                gcode_generated[s][x] = GStatus[x] + " F" + printing_speed + " X" + pos_x[x] + " Y" + pos_y[x] + " Z" + pos_z[x] + " E" + mainViewModel.feed_rate + ";\n";
                            }
                        }
                    } else if (layerStatus[x] === "LAYER") {
                        if (l >= 1 && l <= mainViewModel.fan_layer) {
                            if (l === 1) {
                                gcode_generated[s][x] = "M104 S" + mainViewModel.regular_nozzle + ";\n" + ";LAYER:" + l + "\n" +
                                    "M106 S" + Math.round(l * (mainViewModel.fan_speed * (255 / 100) * 10) / mainViewModel.fan_layer) / 10 + ";\n";
                            } else {
                                gcode_generated[s][x] = ";LAYER:" + l + "\n" +
                                    "M106 S" + Math.round(l * (mainViewModel.fan_speed * (255 / 100) * 10) / mainViewModel.fan_layer) / 10 + ";\n";
                            }
                        } else {
                            gcode_generated[s][x] = ";LAYER:" + l + "\n"
                        }
                        l++;
                    }
                }
                if (mainViewModel.variable.relative_positioning) {
                    if (s > 1) {
                        gcode_generated[s].unshift("M104 S" + document.getElementById("inputListTemp" + s).value + ";\n" +
                            "M117 St" + s + "/" + t + " Temp" + document.getElementById("inputListTemp" + s).value + ";\n" +
                            "G0 F" + mainViewModel.travel_speed + " Z" + mainViewModel.variable.nozzle_size / 2 + "\n" +
                            "G0 F" + mainViewModel.travel_speed + " X" + returningPosX + " Y" + returningPosY + ";\n");
                    } else {
                        gcode_generated[s].unshift("M104 S" + document.getElementById("inputListTemp" + s).value + ";\n" +
                            "M117 St" + s + "/" + t + " Temp" + document.getElementById("inputListTemp" + s).value + ";\n");
                    }
                } else {
                    if (s > 1) {
                        gcode_generated[s].unshift("M104 S" + document.getElementById("inputListTemp" + s).value + ";\n" +
                            "M117 St" + s + "/" + t + " Temp" + document.getElementById("inputListTemp" + s).value + ";\n" +
                            "G0 F" + mainViewModel.travel_speed + " X" + returningPosX + " Y" + returningPosY +
                            " Z" + (startZHeight[s] + parseFloat(mainViewModel.variable.nozzle_size)/2) + ";\n");
                    } else {
                        gcode_generated[s].unshift("M117 St" + s + "/" + t + " Temp" + document.getElementById("inputListTemp" + s).value +";\n");
                    }
                }
            }
            if (mainViewModel.variable.relative_positioning) {
                gcode_generated.splice(0, 1);
                gcode_generated.unshift("G91;\n")
            }

            mainViewModel.getSettings();

            for (const [key, value] of Object.entries(mainViewModel.settingsSquare)) {
                start_gcode = start_gcode.replaceAll("[" + key + "]", value);
            }
            gcode_generated.unshift("G28;\n\n" +
                ";---------ABL METHOD---------\n" + mainViewModel.abl_method + ";\n;---------ABL METHOD---------\n\n" +
                ";---------START G-CODE---------\n" + start_gcode + ";\n;---------START G-CODE---------\n\n" +
                "G0 F" + mainViewModel.travel_speed + " X" + first_x_absolute_pos + " Y" + first_y_absolute_pos +
                ";\n" + "G0 F" + mainViewModel.travel_speed + " Z" + mainViewModel.variable.nozzle_size / 2 + ";\n")

            for (const [key, value] of Object.entries(mainViewModel.settingsSquare)) {
                end_gcode = end_gcode.replaceAll("[" + key + "]", value);
            }
            gcode_generated.push(end_gcode);

            let url = OctoPrint.getBlueprintUrl('calibrationcompanion') + "echo";
            OctoPrint.post(url, {"name": mainViewModel.getFullFilename(mainViewModel.filename), "generated gcode": gcode_generated.flat().join('')})

            gcode_generated = [];
            pos_x = [];
            pos_y = [];
            pos_z = [];
            startZHeight = [];
            startFeedRate = []
        }

        function tempTowerCoord(nozzle_size) {
            /*if (nozzle_size === 0.4) {
                GStatus = ['null',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G0',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0'];
                EStatus = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                layerStatus = ['LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                relative_pos_x = ['null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-6.02',	'0',	'6.02',	'0',	'0.28',	'0',	'-0.441',	'-0.448',	'-0.566',	'1.014',	'0',	'-1.579',	'-0.566',	'2.145',	'0',	'-2.711',	'-0.565',	'3.276',	'0',	'-3.842',	'-0.566',	'4.408',	'0',	'-4.973',	'-0.566',	'5.539',	'-0.406',	'-5.294',	'0',	'4.729',	'-0.566',	'-4.163',	'0',	'3.597',	'-0.565',	'-3.032',	'0',	'2.466',	'-0.566',	'-1.9',	'0',	'1.335',	'-0.566',	'-0.769',	'0',	'0.203',	'0',	'null',	'0',	'6.228',	'1.085',	'22.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'0.24',	'0.28',	'0',	'6.02',	'0',	'-6.02',	'0.607',	'-0.448',	'0',	'1.014',	'0.565',	'-1.579',	'0',	'2.145',	'0.566',	'-2.711',	'0',	'3.277',	'0.565',	'-3.842',	'0',	'4.408',	'0.566',	'-4.974',	'0',	'5.539',	'0.161',	'-5.294',	'0.565',	'4.729',	'0',	'-4.163',	'0.566',	'3.597',	'0',	'-3.032',	'0.566',	'2.466',	'0',	'-1.9',	'0.565',	'1.335',	'0',	'-0.769',	'0.566',	'0.203',	'0.351',	'null',	'0',	'0.09',	'-0.072',	'-6.798',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-6.02',	'0',	'6.02',	'0',	'-0.283',	'0.122',	'0',	'-0.688',	'-0.565',	'1.253',	'0',	'-1.819',	'-0.566',	'2.385',	'0',	'-2.95',	'-0.566',	'3.516',	'0',	'-4.082',	'-0.565',	'4.647',	'0',	'-5.213',	'-0.487',	'5.622',	'-0.566',	'-5.056',	'0',	'4.491',	'-0.566',	'-3.925',	'0',	'3.359',	'-0.566',	'-2.793',	'0',	'2.228',	'-0.566',	'-1.662',	'0',	'1.096',	'-0.565',	'-0.531',	'-0.349',	'null',	'-0.09',	'0.072',	'6.798',	'1.085',	'22.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'0.24',	'0.28',	'0',	'6.02',	'0',	'-6.02',	'-0.28',	'0.072',	'0.575',	'0',	'-0.208',	'0',	'0.774',	'0.566',	'-1.34',	'0',	'1.905',	'0.566',	'-2.471',	'0',	'3.037',	'0.566',	'-3.603',	'0',	'4.168',	'0.566',	'-4.734',	'0',	'5.3',	'0.4',	'-5.535',	'0.565',	'4.97',	'0',	'-4.404',	'0.566',	'3.838',	'0',	'-3.273',	'0.566',	'2.707',	'0',	'-2.141',	'0.565',	'1.576',	'0',	'-1.01',	'0.566',	'0.444',	'0.351',	'null',	'0',	'0.09',	'-0.072',	'-6.798',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-1.182',	'-5.668',	'1.857',	'4.783',	'0',	'-1.955',	'-4.685',	'2.84',	'0',	'null',	'4.06',	'1.085',	'22.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'2.163',	'-1.954',	'0',	'4.782',	'1.857',	'-5.668',	'2.829',	'2.839',	'-0.118',	'0',	'-6.7',	'-0.057',	'null',	'0',	'6.957',	'0',	'-6.957',	'-0.4',	'0',	'7.757',	'0',	'-7.757',	'0.27',	'1.337',	'5.668',	'-1.857',	'-4.939',	'0',	'2.111',	'4.685',	'-2.839',	'0',	'null',	'-4.216',	'-1.085',	'-22.419',	'-1.085',	'-0.18',	'null',	'-6.894',	'0',	'6.894',	'0',	'0.4',	'-7.694',	'0',	'7.694',	'0',	'-0.27',	'-2.258',	'2.047',	'0',	'-4.876',	'-1.857',	'5.669',	'-2.828',	'-2.841',	'0.12',	'null',	'0',	'6.874',	'1.085',	'22.419',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'7.29',	'0',	'-7.29',	'-0.4',	'0',	'8.09',	'0',	'-8.09',	'0.27',	'2.653',	'-2.444',	'0',	'5.272',	'1.857',	'-5.668',	'2.829',	'2.839',	'-0.118',	'null',	'-7.27',	'-1.085',	'-21.886',	'-1.085',	'-0.18',	'null',	'-7.094',	'0',	'7.094',	'0',	'0.4',	'-7.894',	'0',	'7.894',	'0',	'-0.27',	'-1.476',	'-5.668',	'1.857',	'5.077',	'0',	'-2.249',	'-4.685',	'2.84',	'0',	'null',	'0',	'4.354',	'1.085',	'21.886',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'7.623',	'0',	'-7.623',	'-0.4',	'0',	'8.423',	'0',	'-8.423',	'0.27',	'0.208',	'5.606',	'1.857',	'-5.668',	'2.829',	'2.839',	'-4.685',	'-2.778',	'0.122',	'null',	'-0.38',	'-1.085',	'-21.353',	'-1.085',	'-0.18',	'null',	'-7.294',	'0',	'7.294',	'0',	'0.4',	'-8.094',	'0',	'8.094',	'0',	'-0.27',	'-2.657',	'2.446',	'0',	'-5.275',	'-1.858',	'5.669',	'-2.828',	'-2.841',	'0.12',	'null',	'0',	'7.274',	'1.085',	'21.353',	'1.085',	'0.08',	'-0.234',	'null',	'null',	'0',	'7.957',	'0',	'-7.957',	'-0.4',	'0',	'8.757',	'0',	'-8.757',	'0.762',	'-0.283',	'0',	'3.111',	'2.828',	'-5.939',	'2.128',	'5.668',	'0',	'-2.839',	'0',	'null',	'-5.216',	'-1.085',	'-20.819',	'-1.085',	'-0.18',	'null',	'-7.494',	'0',	'7.494',	'0',	'0.4',	'-8.294',	'0',	'8.294',	'0',	'-0.27',	'-0.21',	'-5.477',	'-1.857',	'5.668',	'-2.828',	'-2.84',	'4.685',	'2.649',	'-0.12',	'null',	'0',	'0.38',	'1.085',	'20.819',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'8.29',	'0',	'-8.29',	'-0.4',	'0',	'9.09',	'0',	'-9.09',	'0.479',	'6.272',	'1.857',	'-5.669',	'2.829',	'2.84',	'-4.685',	'-3.444',	'0',	'0.616',	'0',	'null',	'-0.875',	'-1.085',	'-20.286',	'-1.085',	'-0.18',	'null',	'-7.694',	'0',	'7.694',	'0',	'0.4',	'-8.494',	'0',	'8.494',	'0',	'-0.27',	'-3.057',	'2.846',	'0',	'-5.675',	'-1.858',	'5.669',	'-2.828',	'-2.841',	'0.12',	'null',	'0',	'7.674',	'1.085',	'20.286',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'8.623',	'0',	'-8.623',	'-0.4',	'0',	'9.423',	'0',	'-9.423',	'0.27',	'1.158',	'-0.949',	'0',	'3.777',	'2.828',	'-6.605',	'2.794',	'5.668',	'0',	'-2.839',	'0',	'null',	'-5.882',	'-1.085',	'-19.753',	'-1.085',	'-0.18',	'null',	'-7.894',	'0',	'7.894',	'0',	'0.4',	'-8.694',	'0',	'8.694',	'0',	'-0.27',	'-0.211',	'-5.876',	'-1.857',	'5.668',	'-2.828',	'-2.84',	'4.685',	'3.048',	'0',	'-0.219',	'0',	'null',	'0',	'0.48',	'1.085',	'19.753',	'1.085',	'0.08',	'-0.234',	'null',	'null',	'0',	'8.957',	'0',	'-8.957',	'-0.4',	'0',	'9.757',	'0',	'-9.757',	'0.779',	'6.639',	'1.857',	'-5.668',	'2.829',	'2.839',	'-4.685',	'-4.111',	'0',	'1.283',	'0',	'null',	'-1.542',	'-1.085',	'-19.219',	'-1.085',	'-0.18',	'null',	'-8.094',	'0',	'8.094',	'0',	'0.4',	'-8.894',	'0',	'8.894',	'0',	'-0.27',	'-0.629',	'0.419',	'0',	'-3.247',	'-2.829',	'6.076',	'-2.265',	'-5.669',	'0',	'2.841',	'0',	'null',	'0',	'5.353',	'1.085',	'19.219',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'9.29',	'0',	'-9.29',	'-0.4',	'0',	'10.09',	'0',	'-10.09',	'0.27',	'1.825',	'-1.616',	'0',	'4.444',	'2.828',	'-6.639',	'2.828',	'5.668',	'0',	'-2.839',	'0',	'null',	'-6.549',	'-1.085',	'-18.686',	'-1.085',	'-0.18',	'null',	'-8.294',	'0',	'8.294',	'0',	'0.4',	'-9.094',	'0',	'9.094',	'0',	'-0.481',	'-6.276',	'-1.857',	'5.668',	'-2.828',	'-2.84',	'4.685',	'3.448',	'0',	'-0.619',	'0',	'null',	'0',	'0.88',	'1.085',	'18.686',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'9.623',	'0',	'-9.623',	'-0.4',	'0',	'10.423',	'0',	'-10.423',	'0.27',	'1.175',	'6.639',	'1.857',	'-5.668',	'2.829',	'2.839',	'-4.685',	'-4.777',	'0',	'1.949',	'0',	'null',	'-2.208',	'-1.085',	'-18.153',	'-1.085',	'-0.18',	'null',	'-8.494',	'0',	'8.494',	'0',	'0.4',	'-9.294',	'0',	'9.294',	'0',	'-0.27',	'-1.029',	'0.819',	'0',	'-3.647',	'-2.829',	'6.476',	'-2.665',	'-5.669',	'0',	'2.841',	'0',	'null',	'0',	'5.753',	'1.085',	'18.153',	'1.085',	'0.08',	'-0.234',	'null',	'null',	'0',	'9.957',	'0',	'-9.957',	'-0.4',	'0',	'10.757',	'0',	'-10.757',	'0.27',	'3.315',	'0.072',	'-0.221',	'2.154',	'2.828',	'-4.982',	'0.221',	'0.95',	'5.668',	'0',	'-2.839',	'-3.779',	'-0.09',	'0',	'-2.777',	'0',	'2.777',	'-0.161',	'-0.591',	'-0.566',	'1.157',	'0',	'-1.723',	'-0.565',	'2.288',	'0',	'-2.457',	'0',	'2.457',	'0',	'-2.457',	'0',	'2.457',	'0',	'-2.457',	'0',	'2.457',	'-0.549',	'-1.908',	'0',	'1.342',	'-0.565',	'-0.777',	'0',	'0.211',	'0',	'null',	'0',	'-0.94',	'-1.085',	'-17.619',	'-1.085',	'-0.18',	'null',	'-8.694',	'0',	'8.694',	'0',	'0.4',	'-9.494',	'0',	'9.494',	'0',	'-0.27',	'-2.052',	'-0.072',	'0.219',	'-4.982',	'-1.857',	'5.668',	'-2.828',	'-2.84',	'4.685',	'2.154',	'-0.219',	'0',	'0.09',	'1.514',	'0',	'-1.514',	'0',	'-0.09',	'0.072',	'1.74',	'0.072',	'-0.44',	'-0.08',	'-0.566',	'0.646',	'0',	'-1.195',	'0',	'1.195',	'0',	'-1.195',	'0',	'1.195',	'0',	'-1.195',	'0',	'1.195',	'0',	'-1.195',	'0',	'1.195',	'-0.038',	'-1.157',	'0',	'0.592',	'0',	'null',	'0',	'0',	'1.333',	'1.085',	'17.619',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'10.29',	'0',	'-10.29',	'-0.4',	'0',	'11.09',	'0',	'-11.09',	'0.27',	'3.648',	'0.072',	'-0.221',	'4.982',	'1.857',	'-5.668',	'2.829',	'2.839',	'-4.685',	'-2.154',	'0.221',	'0',	'-0.09',	'0',	'-3.11',	'0',	'3.11',	'0.09',	'-0.064',	'-2.673',	'0',	'-0.304',	'0',	'0.869',	'0.566',	'-1.435',	'0',	'2.001',	'0.565',	'-2.566',	'0',	'2.79',	'0',	'-2.79',	'0',	'2.79',	'0',	'-2.79',	'0',	'2.79',	'0',	'-2.529',	'0.566',	'1.963',	'0',	'-1.397',	'0.565',	'0.832',	'0',	'-0.266',	'0',	'null',	'0',	'-3.253',	'-1.085',	'-17.086',	'-1.085',	'-0.18',	'null',	'-8.894',	'0',	'8.894',	'0',	'0.4',	'-9.694',	'0',	'9.694',	'0',	'-0.27',	'-2.252',	'-0.072',	'0.219',	'-2.152',	'-2.829',	'4.981',	'-0.219',	'-0.951',	'-5.669',	'0',	'2.841',	'3.779',	'0.09',	'1.714',	'0',	'-1.714',	'0',	'0.159',	'0.353',	'0.565',	'-0.918',	'0',	'1.394',	'0',	'-1.394',	'0',	'1.394',	'0',	'-1.394',	'0',	'1.394',	'0',	'-1.394',	'0',	'1.394',	'0',	'-1.394',	'0.309',	'1.085',	'0',	'-0.519',	'0',	'null',	'0',	'0',	'1.25',	'1.085',	'17.086',	'1.085',	'0.08',	'-0.233',	'null',	'null',	'0',	'10.623',	'0',	'-10.623',	'-0.4',	'0',	'11.423',	'0',	'-11.423',	'0.27',	'3.981',	'0.072',	'-0.221',	'2.154',	'2.828',	'-4.982',	'0.221',	'0.95',	'5.668',	'0',	'-2.839',	'-3.779',	'-0.09',	'0',	'-3.443',	'0',	'3.443',	'-0.161',	'-0.591',	'-0.566',	'1.157',	'0',	'-1.723',	'-0.565',	'2.288',	'0',	'-2.854',	'-0.27',	'3.124',	'0',	'-3.124',	'0',	'3.124',	'0',	'-3.124',	'0',	'3.124',	'-0.549',	'-2.575',	'0',	'2.009',	'-0.565',	'-1.444',	'0',	'0.878',	'-0.566',	'-0.312',	'-0.348',	'null',	'-0.09',	'-0.29',	'-1.085',	'-16.553',	'-1.085',	'-0.18',	'null',	'-9.094',	'0',	'9.094',	'0',	'0.4',	'-9.894',	'0',	'9.894',	'0',	'-0.27',	'-2.452',	'-0.072',	'0.219',	'-4.982',	'-1.857',	'5.668',	'-2.828',	'-2.84',	'4.685',	'2.154',	'-0.219',	'0',	'0.09',	'1.914',	'0',	'-1.914',	'0',	'-0.09',	'0.072',	'2.14',	'0.072',	'-0.441',	'-0.479',	'-0.566',	'1.045',	'0',	'-1.594',	'0',	'1.594',	'0',	'-1.594',	'0',	'1.594',	'0',	'-1.594',	'0',	'1.594',	'0',	'-1.594',	'0',	'1.594',	'-0.437',	'-1.157',	'0',	'0.592',	'0',	'null',	'0',	'0',	'1.733',	'1.085',	'16.553',	'1.085',	'0.08',	'-0.234',	'null',	'null',	'0',	'10.957',	'0',	'-10.957',	'-0.4',	'0',	'11.757',	'0',	'-11.757',	'0.27',	'4.315',	'0.072',	'-0.221',	'4.982',	'1.857',	'-5.668',	'2.829',	'2.839',	'-4.685',	'-2.154',	'0.221',	'0',	'-0.09',	'0',	'-3.777',	'0',	'3.777',	'0.09',	'-0.072',	'-4.003',	'-0.072',	'0.439',	'0.406',	'0.565',	'-0.971',	'0',	'1.537',	'0.566',	'-2.103',	'0',	'2.668',	'0.566',	'-3.234',	'0',	'3.457',	'0',	'-3.457',	'0',	'3.457',	'0',	'-3.457',	'0.362',	'3.095',	'0',	'-2.53',	'0.566',	'1.964',	'0',	'-1.398',	'0.565',	'0.833',	'0',	'-0.267',	'0',	'null',	'0',	'-3.919',	'-1.085',	'-16.019',	'-1.085',	'-0.18',	'null',	'-9.294',	'0',	'9.294',	'0',	'0.4',	'-10.094',	'0',	'10.094',	'0',	'-0.27',	'-2.652',	'-0.072',	'0.219',	'-2.152',	'-2.829',	'4.981',	'-0.219',	'-0.951',	'-5.669',	'0',	'2.841',	'3.779',	'0.09',	'2.114',	'0',	'-2.114',	'0',	'0.159',	'0.353',	'0.566',	'-0.919',	'0',	'1.485',	'0.309',	'-1.794',	'0',	'1.794',	'0',	'-1.794',	'0',	'1.794',	'0',	'-1.794',	'0',	'1.794',	'0',	'-1.794',	'0.309',	'1.485',	'0',	'-0.919',	'0.566',	'0.353',	'0.351',	'null',	'0',	'0.09',	'0.29',	'1.085',	'16.019',	'1.085',	'0.08',	'-0.234',	'null',	'null',	'0',	'0',	'0.001',	'11.29',	'0',	'-11.2',	'-0.091',	'-0.399',	'-0.001',	'0.001',	'12.09',	'0',	'-12.09',	'0.27',	'4.648',	'0.072',	'-0.221',	'2.154',	'2.828',	'-4.982',	'0.221',	'0.95',	'5.668',	'0',	'-2.839',	'-3.779',	'-0.09',	'0',	'-4.111',	'0.001',	'4.11',	'-0.161',	'-0.591',	'-0.566',	'1.157',	'0',	'-1.723',	'-0.565',	'2.288',	'0',	'-2.854',	'-0.566',	'3.42',	'0',	'-3.791',	'0',	'3.791',	'0',	'-3.791',	'0',	'3.791',	'-0.549',	'-3.242',	'0',	'2.676',	'-0.565',	'-2.111',	'0',	'1.545',	'-0.566',	'-0.979',	'0',	'0.414',	'0',	'null',	'0',	'-1.162',	'-1.065',	'-15.486',	'-1.085',	'-0.18',	'null',	'-9.494',	'0',	'9.494',	'0',	'0.4',	'-10.294',	'0',	'10.294',	'0',	'-0.27',	'-2.852',	'-0.072',	'0.219',	'-4.982',	'-1.857',	'5.668',	'-2.828',	'-2.84',	'4.685',	'2.154',	'-0.219',	'0',	'0.09',	'2.22',	'0',	'0.094',	'0',	'-2.314',	'0',	'-0.09',	'0.072',	'2.446',	'0.072',	'-0.441',	'-0.22',	'-0.565',	'0.785',	'0',	'-1.351',	'-0.549',	'1.9',	'0.094',	'-1.994',	'0',	'1.994',	'0',	'-1.994',	'0',	'1.994',	'0',	'-1.994',	'0',	'1.994',	'-0.271',	'-1.723',	'0',	'1.157',	'-0.565',	'-0.592',	'-0.249',	'0.072',	'2.54',	'0.072',	'-0.152',	'0.007',	'0',	'-0.08',	'null',	'0',	'0',	'0.032',	'0.483',	'1.085',	'15.486',	'1.065',	'0.1',	'-0.234',	'null',	'null',	'0',	'0.001',	'11.623',	'0',	'-11.425',	'-0.199',	'-0.4',	'0',	'0.001',	'12.423',	'0',	'-12.424',	'0.27',	'4.982',	'0.072',	'-0.221',	'4.982',	'1.857',	'-5.668',	'2.829',	'2.839',	'-4.685',	'-2.154',	'0.221',	'0',	'-0.09',	'0',	'-4.444',	'0.001',	'0.223',	'0',	'4.22',	'0.09',	'-0.072',	'-4.446',	'-0.072',	'0.479',	'0.203',	'0.565',	'-0.768',	'0',	'1.334',	'0.566',	'-1.9',	'-0.223',	'2.688',	'0.566',	'-3.254',	'0',	'3.82',	'0.223',	'-4.044',	'0',	'4.044',	'0',	'-4.044',	'0.463',	'3.581',	'0',	'-3.015',	'0.566',	'2.449',	'0',	'-1.884',	'0.566',	'1.318',	'0',	'-0.752',	'0.565',	'0.187',	'0.291',	'-0.072',	'-4.67',	'0.001',	'0.151',	'0.087',	'-0.102',	'0',	'-0.082',	'-0.085',	'null',	'-0.332',	'-1.085',	'-14.952',	'-1.085',	'-0.18',	'null',	'-9.694',	'0',	'9.694',	'0',	'0.4',	'-10.494',	'0',	'10.494',	'0',	'-0.27',	'-3.052',	'-0.072',	'0.219',	'-2.152',	'-2.829',	'4.981',	'-0.219',	'-0.951',	'-5.669',	'0',	'2.841',	'6.107',	'0.072',	'-0.221',	'0.734',	'-0.309',	'0',	'-2.514',	'0',	'2.22',	'0',	'0.294',	'0',	'-0.276',	'-2.256',	'-0.072',	'0.289',	'0.273',	'0.566',	'-0.839',	'0',	'1.404',	'0.416',	'-1.82',	'0',	'1.82',	'0',	'-1.82',	'0',	'1.82',	'0.013',	'-1.833',	'0',	'2.114',	'0',	'-2.114',	'0.31',	'1.804',	'0',	'-1.239',	'0.566',	'0.673',	'0',	'-0.107',	'0',	'0',	'0',	'-2.196',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-1.182',	'-5.668',	'1.857',	'4.783',	'0',	'-1.955',	'-4.685',	'2.84',	'0',	'null',	'4.06',	'1.84',	'0.98',	'null',	'-0.8',	'0',	'0.8',	'0',	'0.4',	'-1.6',	'0',	'1.6',	'0',	'-0.827',	'0.026',	'0',	'0.106',	'-0.12',	'-0.211',	'0.116',	'0',	'null',	'0.69',	'1.085',	'14.67',	'1.085',	'0.18',	'null',	'0',	'0.8',	'0',	'-0.8',	'-0.4',	'0',	'1.6',	'0',	'-1.6',	'0.573',	'0.22',	'0.005',	'0',	'0.016',	'0.142',	'-0.068',	'null',	'0.498',	'1.079',	'1.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'2.163',	'-1.954',	'0',	'4.782',	'1.857',	'-5.668',	'2.829',	'2.839',	'-0.118',	'null',	'0',	'-6.78',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-2.163',	'1.953',	'0',	'-4.782',	'-1.858',	'5.669',	'-2.828',	'-2.841',	'0.12',	'null',	'6.78',	'1.84',	'0.98',	'null',	'-0.8',	'0',	'0.8',	'0',	'0.4',	'-1.6',	'0',	'1.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-0.02',	'0',	'0.02',	'0',	'0',	'null',	'0',	'0.57',	'1.085',	'14.67',	'1.085',	'0.18',	'null',	'0',	'0.8',	'0',	'-0.8',	'-0.4',	'0',	'1.6',	'0',	'-1.6',	'0.27',	'0.24',	'0.28',	'0',	'0.02',	'0',	'-0.02',	'-0.19',	'null',	'-0.09',	'0.057',	'0.819',	'1.079',	'1.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'1.18',	'5.668',	'-1.857',	'-4.782',	'0',	'1.954',	'4.685',	'-2.839',	'0',	'null',	'0',	'-4.059',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-1.182',	'-5.668',	'1.857',	'4.783',	'0',	'-1.955',	'-4.685',	'2.84',	'0',	'null',	'4.06',	'1.84',	'0.98',	'null',	'-0.8',	'0',	'0.8',	'0',	'0.4',	'-1.6',	'0',	'1.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-0.02',	'0',	'0.02',	'0',	'0',	'null',	'0',	'0.57',	'1.085',	'14.67',	'1.085',	'0.18',	'null',	'0',	'0.8',	'0',	'-0.8',	'-0.4',	'0',	'1.6',	'0',	'-1.6',	'0.27',	'0.24',	'0.28',	'0',	'0.02',	'0',	'-0.02',	'-0.19',	'null',	'-0.09',	'0.057',	'0.819',	'1.079',	'1.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'2.163',	'-1.954',	'0',	'4.782',	'1.857',	'-5.668',	'2.829',	'2.839',	'-0.118',	'null',	'0',	'-6.78',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-2.163',	'1.953',	'0',	'-4.782',	'-1.858',	'5.669',	'-2.828',	'-2.841',	'0.12',	'null',	'6.78',	'1.84',	'18.98',	'null',	'-1.2',	'-16.4',	'-1',	'-0.2',	'0',	'0',	'1.2',	'16.4',	'1',	'0.2',	'0',	'0',	'0.4',	'-1.6',	'-16.4',	'-1',	'-0.6',	'0',	'1.6',	'16.4',	'1',	'0.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-0.81',	'-16.4',	'-0.81',	'0',	'0.81',	'16.4',	'0.81',	'0',	'-0.001',	'-18.02',	'0',	'18.02',	'0',	'-18.02',	'0',	'18.02',	'0',	'-18.02',	'-0.189',	'null',	'-0.09',	'0.072',	'18.804',	'1.079',	'1.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'1.18',	'5.668',	'-1.857',	'-4.782',	'0',	'1.954',	'4.685',	'-2.839',	'0',	'null',	'0',	'-4.059',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-1.182',	'-5.668',	'1.857',	'4.783',	'0',	'-1.955',	'-4.685',	'2.84',	'0',	'null',	'4.06',	'1.84',	'18.98',	'null',	'-18.8',	'0',	'18.8',	'0',	'0.4',	'-19.6',	'0',	'19.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-18.02',	'0',	'18.02',	'0',	'-0.255',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'-0.533',	'0',	'0',	'null',	'0',	'18.42',	'1.079',	'1.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'2.163',	'-1.954',	'0',	'4.782',	'1.857',	'-5.668',	'2.829',	'2.839',	'-0.118',	'null',	'0',	'-6.78',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-2.163',	'1.953',	'0',	'-4.782',	'-1.858',	'5.669',	'-2.828',	'-2.841',	'0.12',	'null',	'6.78',	'1.84',	'18.98',	'null',	'-18.8',	'0',	'18.8',	'0',	'0.4',	'-19.6',	'0',	'19.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-18.02',	'0',	'18.02',	'0',	'-0.162',	'-0.151',	'-0.566',	'0.717',	'0',	'-1.282',	'-0.566',	'1.701',	'-0.565',	'-1.702',	'-0.565',	'1.701',	'-0.566',	'-1.701',	'-0.566',	'1.701',	'-0.565',	'-1.701',	'-0.566',	'1.701',	'-0.566',	'-1.701',	'-0.566',	'1.702',	'-0.566',	'-1.701',	'-0.566',	'1.701',	'-0.565',	'-1.702',	'-0.565',	'1.701',	'-0.566',	'-1.7',	'-0.566',	'1.701',	'-0.566',	'-1.701',	'-0.565',	'1.7',	'-0.565',	'-1.701',	'-0.566',	'1.701',	'-0.566',	'-1.7',	'-0.566',	'1.701',	'-0.566',	'-1.701',	'-0.565',	'1.7',	'-0.566',	'-1.7',	'-0.566',	'1.701',	'-0.566',	'-1.7',	'-0.566',	'1.7',	'-0.565',	'-1.701',	'-0.566',	'1.701',	'-0.566',	'-1.147',	'0',	'0.582',	'0',	'null',	'0',	'-0.949',	'0',	'18.804',	'1.079',	'1.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'1.18',	'5.668',	'-1.857',	'-4.782',	'0',	'1.954',	'4.685',	'-2.839',	'0',	'null',	'0',	'-4.059',	'-1.085',	'-22.67',	'-1.085',	'-0.18',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-6.02',	'0',	'6.02',	'0',	'0.28',	'0',	'-0.48',	'-0.369',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.411',	'-0.159',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.688',	'0.156',	'0.41',	'0.156',	'0.41',	'0.155',	'0.41',	'0.156',	'0.41',	'0.156',	'0.41',	'0.155',	'0.411',	'0.155',	'0.41',	'0.156',	'0.41',	'0.406',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.89',	'-0.072',	'-5.905',	'0',	'-0.123',	'0.884',	'-0.514',	'0',	'1.08',	'0.566',	'-1.646',	'0',	'2.211',	'0.566',	'-2.777',	'0',	'3.343',	'0.565',	'-3.908',	'0',	'4.474',	'0.406',	'-4.72',	'0.566',	'4.154',	'0',	'-3.589',	'0.566',	'3.023',	'0',	'-2.457',	'0.565',	'1.892',	'0',	'-1.326',	'0.566',	'0.76',	'0',	'-0.195',	'0',	'null',	'0',	'0.973',	'0.362',	'1.84',	'18.98',	'null',	'-18.8',	'0',	'18.8',	'0',	'0.4',	'-19.6',	'0',	'19.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-18.02',	'0',	'18.02',	'0',	'0.28',	'0',	'-0.481',	'-0.437',	'-0.566',	'1.003',	'0',	'-1.569',	'-0.565',	'1.62',	'-0.566',	'-1.62',	'-0.566',	'1.62',	'-0.565',	'-1.62',	'-0.566',	'1.62',	'-0.566',	'-1.62',	'-0.565',	'1.62',	'-0.566',	'-1.62',	'-0.566',	'1.62',	'-0.566',	'-1.619',	'-0.566',	'1.62',	'-0.566',	'-1.62',	'-0.566',	'1.62',	'-0.565',	'-1.62',	'-0.566',	'1.62',	'-0.566',	'-1.62',	'-0.565',	'1.619',	'-0.566',	'-1.619',	'-0.566',	'1.62',	'-0.566',	'-1.619',	'-0.566',	'1.619',	'-0.565',	'-1.62',	'-0.565',	'1.619',	'-0.566',	'-1.619',	'-0.566',	'1.619',	'-0.565',	'-1.619',	'-0.566',	'1.619',	'-0.566',	'-1.619',	'-0.212',	'1.266',	'-0.566',	'-0.7',	'0',	'0.134',	'0',	'null',	'0',	'18.263',	'1.079',	'1.67',	'1.085',	'0.18',	'null',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'0.27',	'0.24',	'0.28',	'0',	'6.02',	'0',	'-6.02',	'0.567',	'-0.369',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.406',	'0.41',	'0.156',	'0.41',	'0.156',	'0.41',	'0.155',	'0.41',	'0.156',	'0.41',	'0.156',	'0.41',	'0.155',	'0.411',	'0.155',	'0.41',	'0.156',	'0.688',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.159',	'-0.41',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.411',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.411',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'0',	'5.505',	'0.072',	'-0.482',	'-0.123',	'-0.246',	'-0.514',	'-0.566',	'1.08',	'0',	'-1.646',	'-0.565',	'2.211',	'0',	'-2.777',	'-0.566',	'3.343',	'0',	'-3.909',	'-0.565',	'4.474',	'-0.161',	'-4.719',	'0',	'4.153',	'-0.565',	'-3.588',	'0',	'3.022',	'-0.566',	'-2.456',	'0',	'1.891',	'-0.566',	'-1.325',	'0',	'0.759',	'-0.565',	'-0.194',	'-0.759',	'null',	'0',	'-0.09',	'-0.29',	'-1.085',	'-22.67',	'-1.085',	'-0.29',	'-0.89',	'null',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-4.02',	'0',	'4.02',	'0',	'-0.546',	'0.386',	'0',	'-0.952',	'-0.565',	'1.517',	'0',	'-2.083',	'-0.566',	'2.649',	'0',	'-3.214',	'-0.486',	'3.62',	'-0.565',	'-3.055',	'0',	'2.489',	'-0.566',	'-1.923',	'0',	'1.358',	'-0.566',	'-0.792',	'0',	'0.226',	'0',	'null',	'0',	'3.842',	'0.362',	'1.085',	'24.67',	'1.085',	'0.18',	'null',	'0',	'4.8',	'0',	'-4.8',	'-0.4',	'0',	'5.6',	'0',	'-5.6',	'0.27',	'0.24',	'0.28',	'0',	'4.02',	'0',	'-4.02',	'-0.28',	'0.072',	'0.838',	'0',	'-0.471',	'0',	'1.037',	'0.566',	'-1.603',	'0',	'2.168',	'0.566',	'-2.734',	'0',	'3.3',	'0.4',	'-3.536',	'0.566',	'2.97',	'0',	'-2.404',	'0.565',	'1.839',	'0',	'-1.273',	'0.566',	'0.707',	'0',	'-0.141',	'0',	'null',	'0',	'0',	'-4.288',	'-1.085',	'-24.67',	'-1.085',	'-0.18',	'null',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-4.02',	'0',	'4.02',	'0',	'0.28',	'0',	'-0.44',	'-0.146',	'-0.566',	'0.712',	'0',	'-1.278',	'-0.565',	'1.843',	'0',	'-2.409',	'-0.566',	'2.975',	'0',	'-3.54',	'-0.161',	'3.295',	'-0.566',	'-2.729',	'0',	'2.163',	'-0.565',	'-1.598',	'0',	'1.032',	'-0.566',	'-0.466',	'-0.349',	'null',	'-0.09',	'0.072',	'4.798',	'1.085',	'24.67',	'1.085',	'0.18',	'null',	'0',	'4.8',	'0',	'-4.8',	'-0.4',	'0',	'5.6',	'0',	'-5.6',	'0.27',	'0.24',	'0.28',	'0',	'4.02',	'0',	'-4.02',	'0.304',	'-0.145',	'0',	'0.711',	'0.566',	'-1.277',	'0',	'1.842',	'0.566',	'-2.408',	'0',	'2.974',	'0.565',	'-3.539',	'0.406',	'3.294',	'0',	'-2.729',	'0.566',	'2.163',	'0',	'-1.597',	'0.565',	'1.032',	'0',	'-0.466',	'0',	'null',	'0',	'0',	'-3.601',	'-0.362',	'-1.085',	'-24.67',	'-1.085',	'-0.18',	'null',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-4.02',	'0',	'4.02',	'0',	'-0.546',	'0.386',	'0',	'-0.952',	'-0.565',	'1.517',	'0',	'-2.083',	'-0.566',	'2.649',	'0',	'-3.214',	'-0.486',	'3.62',	'-0.565',	'-3.055',	'0',	'2.489',	'-0.566',	'-1.923',	'0',	'1.358',	'-0.566',	'-0.792',	'0',	'0.226',	'0',	'null',	'0',	'3.842',	'0.362',	'1.085',	'24.67',	'1.085',	'0.18',	'null',	'0',	'4.8',	'0',	'-4.8',	'-0.4',	'0',	'5.6',	'0',	'-5.6',	'0.27',	'0.24',	'0.28',	'0',	'4.02',	'0',	'-4.02',	'-0.28',	'0.072',	'0.838',	'0',	'-0.471',	'0',	'1.037',	'0.566',	'-1.603',	'0',	'2.168',	'0.566',	'-2.734',	'0',	'3.3',	'0.4',	'-3.536',	'0.566',	'2.97',	'0',	'-2.404',	'0.565',	'1.839',	'0',	'-1.273',	'0.566',	'0.707',	'0',	'-0.141',	'0',	'null',	'0',	'0',	'-4.288',	'-1.085',	'-24.67',	'-1.085',	'-0.18',	'null',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-4.02',	'0',	'4.02',	'0',	'0.28',	'0',	'-0.44',	'-0.146',	'-0.566',	'0.712',	'0',	'-1.278',	'-0.565',	'1.843',	'0',	'-2.409',	'-0.566',	'2.975',	'0',	'-3.54',	'-0.161',	'3.295',	'-0.566',	'-2.729',	'0',	'2.163',	'-0.565',	'-1.598',	'0',	'1.032',	'-0.566',	'-0.466',	'-0.349',	'null',	'-0.09',	'0.072',	'4.798',	'1.085',	'24.67',	'1.085',	'0.18',	'null',	'0',	'4.8',	'0',	'-4.8',	'-0.4',	'0',	'5.6',	'0',	'-5.6',	'0.27',	'0.24',	'0.28',	'0',	'4.02',	'0',	'-4.02',	'0.304',	'-0.145',	'0',	'0.711',	'0.566',	'-1.277',	'0',	'1.842',	'0.566',	'-2.408',	'0',	'2.974',	'0.565',	'-3.539',	'0.406',	'3.294',	'0',	'-2.729',	'0.566',	'2.163',	'0',	'-1.597',	'0.565',	'1.032',	'0',	'-0.466',	'0',	'null',	'0',	'0',	'-3.601',	'-0.362',	'-1.085',	'-24.67',	'-1.085',	'-0.18',	'null',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.24',	'-0.28',	'-4.02',	'0',	'4.02',	'0',	'-0.506',	'0.306',	'0',	'-0.871',	'-0.566',	'1.437',	'0',	'-2.003',	'-0.565',	'2.568',	'0',	'-3.134',	'-0.486',	'3.541',	'-0.566',	'-2.975',	'0',	'2.409',	'-0.565',	'-1.844',	'0',	'1.278',	'-0.566',	'-0.712',	'0',	'0.147',	'0',	'null',	'0',	'3.881',	'0.362',	'1.085',	'24.67',	'1.085',	'0.18',	'null',	'0',	'4.8',	'0',	'-4.8',	'-0.4',	'0',	'5.6',	'0',	'-5.6',	'0.27',	'0.24',	'0.28',	'0',	'4.02',	'0',	'-4.02',	'-0.28',	'0',	'0.479',	'0.391',	'0.566',	'-0.957',	'0',	'1.522',	'0.566',	'-2.088',	'0',	'2.654',	'0.565',	'-3.219',	'0.165',	'3.455',	'0',	'-2.89',	'0.566',	'2.324',	'0',	'-1.758',	'0.565',	'1.193',	'0',	'-0.627',	'0.566',	'0.061',	'0.391'];
                relative_pos_y = ['null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.52',	'0',	'0',	'-6.02',	'0',	'6.02',	'0',	'-5.413',	'0',	'-0.448',	'0',	'1.014',	'0.566',	'-1.58',	'0',	'2.145',	'0.566',	'-2.711',	'0',	'3.277',	'0.566',	'-3.843',	'0',	'4.408',	'0.566',	'-4.974',	'0',	'5.54',	'0.159',	'-5.294',	'0.566',	'4.728',	'0',	'-4.162',	'0.565',	'3.597',	'0',	'-3.031',	'0.566',	'2.465',	'0',	'-1.9',	'0.566',	'1.334',	'0',	'-0.768',	'0.565',	'0.203',	'0.352',	'null',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.52',	'0',	'-6.02',	'0',	'6.02',	'0',	'-0.161',	'-0.448',	'-0.566',	'1.014',	'0',	'-1.58',	'-0.565',	'2.145',	'0',	'-2.711',	'-0.566',	'3.277',	'0',	'-3.842',	'-0.566',	'4.408',	'0',	'-4.974',	'-0.565',	'5.539',	'-0.405',	'-5.294',	'0',	'4.728',	'-0.565',	'-4.163',	'0',	'3.597',	'-0.566',	'-3.031',	'0',	'2.465',	'-0.565',	'-1.9',	'0',	'1.334',	'-0.566',	'-0.768',	'0',	'0.203',	'0',	'null',	'0',	'0',	'5.865',	'0.182',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.52',	'0',	'0',	'-6.02',	'0',	'6.02',	'-0.161',	'-0.122',	'-0.566',	'0.688',	'0',	'-1.254',	'-0.565',	'1.819',	'0',	'-2.385',	'-0.566',	'2.951',	'0',	'-3.516',	'-0.566',	'4.082',	'0',	'-4.648',	'-0.565',	'5.213',	'-0.079',	'-5.622',	'0',	'5.056',	'-0.565',	'-4.491',	'0',	'3.925',	'-0.566',	'-3.359',	'0',	'2.793',	'-0.565',	'-2.228',	'0',	'1.662',	'-0.566',	'-1.096',	'0',	'0.531',	'0',	'null',	'0',	'5.539',	'0.182',	'0',	'0',	'0',	'0',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.52',	'0',	'-6.02',	'0',	'6.02',	'0',	'0',	'-6.228',	'-0.072',	'0.439',	'0.209',	'0.565',	'-0.774',	'0',	'1.34',	'0.566',	'-1.906',	'0',	'2.471',	'0.566',	'-3.037',	'0',	'3.603',	'0.565',	'-4.168',	'0',	'4.734',	'0.566',	'-5.3',	'0.166',	'5.535',	'0',	'-4.97',	'0.566',	'4.404',	'0',	'-3.838',	'0.565',	'3.273',	'0',	'-2.707',	'0.566',	'2.141',	'0',	'-1.576',	'0.566',	'1.01',	'0',	'-0.444',	'0',	'null',	'0',	'0',	'0.812',	'0.182',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-5.669',	'-0.971',	'4.783',	'-2.829',	'-1.954',	'3.8',	'2.84',	'-0.119',	'null',	'0.2',	'0',	'0',	'0',	'0',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-1.954',	'-2.829',	'4.783',	'-0.971',	'-5.668',	'0',	'2.839',	'0',	'0',	'3.881',	'0',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-5.668',	'-0.971',	'4.939',	'-2.828',	'-2.111',	'3.8',	'2.839',	'-0.119',	'null',	'0.2',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-2.047',	'-2.828',	'4.875',	'-0.971',	'-5.669',	'0',	'2.841',	'0',	'null',	'0',	'3.88',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-2.443',	'-2.829',	'5.272',	'-0.971',	'-5.668',	'0',	'2.839',	'0',	'null',	'3.881',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-5.669',	'-0.971',	'5.077',	'-2.829',	'-2.248',	'3.8',	'2.84',	'-0.119',	'null',	'0',	'0.2',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-1.244',	'-5.606',	'0.971',	'5.668',	'0',	'-2.839',	'-3.8',	'2.777',	'0',	'null',	'3.943',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-2.447',	'-2.828',	'5.275',	'-0.971',	'-5.669',	'0',	'2.841',	'0',	'null',	'0',	'3.88',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.481',	'-0.283',	'-2.828',	'3.111',	'0',	'-5.939',	'-0.7',	'5.668',	'-2.829',	'-2.839',	'0.12',	'null',	'6.6',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-1.374',	'-5.477',	'0.971',	'5.669',	'0',	'-2.84',	'-3.8',	'2.649',	'0',	'null',	'0',	'4.072',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.848',	'-6.272',	'0.971',	'5.669',	'0',	'-2.84',	'-3.8',	'3.443',	'-2.828',	'-0.615',	'0.12',	'null',	'6.6',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-2.847',	'-2.829',	'5.676',	'-0.971',	'-5.669',	'0',	'2.841',	'0',	'null',	'0',	'3.88',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-0.949',	'-2.828',	'3.777',	'0',	'-6.605',	'-0.034',	'5.668',	'-2.829',	'-2.839',	'0.12',	'null',	'6.6',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.974',	'-5.877',	'0.971',	'5.669',	'0',	'-2.84',	'-3.8',	'3.048',	'-2.828',	'-0.22',	'0.121',	'null',	'0',	'6.6',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.481',	'-6.639',	'0.971',	'5.668',	'0',	'-2.839',	'-3.8',	'4.111',	'-2.829',	'-1.282',	'0.12',	'null',	'6.6',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-0.419',	'-2.828',	'3.247',	'0',	'-6.076',	'-0.564',	'5.669',	'-2.828',	'-2.841',	'0.121',	'null',	'0',	'6.6',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-1.615',	'-2.829',	'4.444',	'0',	'-6.639',	'0',	'5.668',	'-2.829',	'-2.839',	'0.12',	'null',	'6.6',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.845',	'-6.276',	'0.971',	'5.669',	'0',	'-2.84',	'-3.8',	'3.448',	'-2.829',	'-0.619',	'0.121',	'null',	'0',	'6.6',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-6.639',	'0.971',	'5.668',	'0',	'-2.839',	'-3.8',	'4.777',	'-2.829',	'-1.948',	'0.12',	'null',	'6.6',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-0.819',	'-2.829',	'3.648',	'0',	'-6.476',	'-0.164',	'5.669',	'-2.828',	'-2.841',	'0.121',	'null',	'0',	'6.6',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.312',	'-2.053',	'0',	'2.154',	'0',	'-4.982',	'0',	'-1.657',	'5.668',	'-2.829',	'-2.839',	'0.31',	'0',	'6.02',	'0',	'-6.02',	'0',	'0.751',	'-0.591',	'0',	'1.157',	'0.565',	'-1.722',	'0',	'2.288',	'0.566',	'-2.458',	'0.566',	'2.457',	'0.566',	'-2.457',	'0.566',	'2.457',	'0.565',	'-2.457',	'0.566',	'2.457',	'0.017',	'-1.908',	'0.565',	'1.343',	'0',	'-0.777',	'0.566',	'0.211',	'0.351',	'null',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.312',	'-1.557',	'0',	'-4.982',	'0.971',	'5.669',	'0',	'-2.84',	'-3.8',	'2.154',	'0',	'-1.843',	'0',	'0',	'6.02',	'0',	'-6.02',	'0',	'-0.208',	'0',	'0.447',	'0',	'-0.08',	'0',	'0.646',	'0.565',	'-1.194',	'0.566',	'1.194',	'0.566',	'-1.195',	'0.566',	'1.194',	'0.566',	'-1.194',	'0.565',	'1.195',	'0.565',	'-1.194',	'0.566',	'1.194',	'0.528',	'-1.156',	'0.565',	'0.591',	'0.352',	'null',	'0',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.312',	'-1.556',	'0',	'-4.982',	'0.971',	'5.668',	'0',	'-2.839',	'-3.8',	'2.153',	'0',	'-1.843',	'0',	'6.02',	'0',	'-6.02',	'0',	'0',	'-0.187',	'-0.093',	'0.44',	'0.304',	'0.566',	'-0.87',	'0',	'1.435',	'0.566',	'-2.001',	'0',	'2.567',	'0.565',	'-2.79',	'0.566',	'2.79',	'0.566',	'-2.791',	'0.566',	'2.79',	'0.566',	'-2.79',	'0.565',	'2.529',	'0',	'-1.963',	'0.566',	'1.397',	'0',	'-0.831',	'0.565',	'0.266',	'0.351',	'null',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.312',	'-2.052',	'0',	'2.153',	'0',	'-4.981',	'0',	'-1.659',	'5.669',	'-2.828',	'-2.841',	'0.311',	'0',	'0',	'6.02',	'0',	'-6.02',	'0.511',	'-0.352',	'0',	'0.918',	'0.566',	'-1.394',	'0.566',	'1.393',	'0.566',	'-1.394',	'0.566',	'1.394',	'0.565',	'-1.393',	'0.565',	'1.394',	'0.566',	'-1.394',	'0.566',	'1.393',	'0.257',	'-1.085',	'0.566',	'0.519',	'0.351',	'null',	'0',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.312',	'-2.053',	'0',	'2.154',	'0',	'-4.982',	'0',	'-1.657',	'5.668',	'-2.829',	'-2.839',	'0.31',	'0',	'6.02',	'0',	'-6.02',	'0',	'0.751',	'-0.591',	'0',	'1.157',	'0.565',	'-1.722',	'0',	'2.288',	'0.566',	'-2.854',	'0.296',	'3.123',	'0.566',	'-3.123',	'0.565',	'3.124',	'0.565',	'-3.123',	'0.566',	'3.123',	'0.017',	'-2.575',	'0.566',	'2.009',	'0',	'-1.443',	'0.566',	'0.877',	'0',	'-0.312',	'0',	'null',	'0',	'0.863',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.312',	'-1.557',	'0',	'-4.982',	'0.971',	'5.669',	'0',	'-2.84',	'-3.8',	'2.154',	'0',	'-1.843',	'0',	'0',	'6.02',	'0',	'-6.02',	'0',	'-0.208',	'0',	'0.847',	'0',	'-0.48',	'0',	'1.045',	'0.566',	'-1.594',	'0.566',	'1.594',	'0.565',	'-1.594',	'0.566',	'1.594',	'0.566',	'-1.594',	'0.565',	'1.594',	'0.566',	'-1.594',	'0.566',	'1.594',	'0.128',	'-1.156',	'0.565',	'0.591',	'0.352',	'null',	'0',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.312',	'-1.556',	'0',	'-4.982',	'0.971',	'5.668',	'0',	'-2.839',	'-3.8',	'2.153',	'0',	'-1.843',	'0',	'6.02',	'0',	'-6.02',	'0',	'0',	'-0.208',	'0',	'0.773',	'0',	'-0.406',	'0',	'0.972',	'0.565',	'-1.537',	'0',	'2.103',	'0.566',	'-2.669',	'0',	'3.234',	'0.566',	'-3.457',	'0.566',	'3.457',	'0.565',	'-3.457',	'0.566',	'3.457',	'0.204',	'-3.095',	'0.565',	'2.53',	'0',	'-1.964',	'0.566',	'1.398',	'0',	'-0.832',	'0.565',	'0.267',	'0.35',	'null',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.312',	'-2.052',	'0',	'2.153',	'0',	'-4.981',	'0',	'-1.659',	'5.669',	'-2.828',	'-2.841',	'0.311',	'0',	'0',	'6.02',	'0',	'-6.02',	'0.511',	'-0.353',	'0',	'0.919',	'0.566',	'-1.485',	'0.256',	'1.794',	'0.566',	'-1.794',	'0.566',	'1.794',	'0.565',	'-1.794',	'0.566',	'1.794',	'0.566',	'-1.794',	'0.565',	'1.794',	'0.257',	'-1.485',	'0.566',	'0.919',	'0',	'-0.353',	'0',	'null',	'0',	'0',	'0.904',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'-0.216',	'-0.091',	'-6.493',	'0',	'6.8',	'0',	'0',	'0.4',	'-0.615',	'-6.985',	'0',	'7.6',	'0',	'-0.27',	'-0.312',	'-2.053',	'0',	'2.154',	'0',	'-4.982',	'0',	'-1.657',	'5.668',	'-2.829',	'-2.839',	'0.31',	'0',	'6.02',	'0',	'-6.02',	'0',	'0.751',	'-0.591',	'0',	'1.157',	'0.565',	'-1.722',	'0',	'2.288',	'0.566',	'-2.854',	'0',	'3.419',	'0.566',	'-3.791',	'0.566',	'3.791',	'0.565',	'-3.79',	'0.565',	'3.791',	'0.017',	'-3.242',	'0.566',	'2.676',	'0',	'-2.111',	'0.566',	'1.545',	'0',	'-0.979',	'0.565',	'0.414',	'0.351',	'null',	'0.09',	'0.068',	'0.002',	'-0.002',	'0',	'0.042',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.312',	'-1.557',	'0',	'-4.982',	'0.971',	'5.669',	'0',	'-2.84',	'-3.8',	'2.154',	'0',	'-1.843',	'0',	'0',	'2.4',	'0',	'3.62',	'0',	'-6.02',	'0',	'-0.208',	'0',	'0.587',	'0',	'-0.22',	'0',	'0.786',	'0.565',	'-1.351',	'0.017',	'1.9',	'0.66',	'-1.994',	'0.565',	'1.994',	'0.566',	'-1.994',	'0.566',	'1.994',	'0.566',	'-1.995',	'0.566',	'1.994',	'0.294',	'-1.722',	'0.566',	'1.156',	'0',	'-0.591',	'0',	'0.961',	'0',	'-3.979',	'-0.073',	'-0.276',	'-1.98',	'-0.11',	'null',	'0',	'-0.09',	'0.039',	'6.651',	'0',	'-0.04',	'-0.002',	'0.042',	'0',	'null',	'null',	'-0.199',	'-6.601',	'0',	'6.8',	'0',	'0',	'0.4',	'-0.083',	'-7.517',	'0',	'7.6',	'0',	'-0.27',	'-0.312',	'-1.556',	'0',	'-4.982',	'0.971',	'5.668',	'0',	'-2.839',	'-3.8',	'2.153',	'0',	'-1.843',	'0',	'6.02',	'0',	'-3.62',	'0',	'-2.4',	'0',	'0',	'-0.208',	'0',	'0.61',	'0',	'-0.203',	'0',	'0.768',	'0.566',	'-1.334',	'0',	'1.9',	'0.789',	'-2.689',	'0',	'3.254',	'0.566',	'-3.82',	'0.343',	'4.044',	'0.565',	'-4.044',	'0.566',	'4.044',	'0.102',	'-3.58',	'0.565',	'3.015',	'0',	'-2.449',	'0.566',	'1.883',	'0',	'-1.318',	'0.566',	'0.752',	'0',	'-0.186',	'0',	'0.595',	'0',	'-4.036',	'-0.025',	'0.041',	'-0.18',	'-1.98',	'-0.202',	'-0.036',	'null',	'6.604',	'0',	'0',	'0',	'-0.004',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.312',	'-2.052',	'0',	'2.153',	'0',	'-4.981',	'0',	'-1.659',	'5.669',	'-2.828',	'-2.841',	'0.103',	'2.424',	'0',	'-0.734',	'0.918',	'3.62',	'0',	'-6.02',	'0',	'2.4',	'0',	'-0.09',	'-2.518',	'0',	'0.68',	'0',	'-0.273',	'0',	'0.838',	'0.566',	'-1.404',	'0.15',	'1.82',	'0.565',	'-1.82',	'0.566',	'1.82',	'0.566',	'-1.82',	'0.553',	'1.832',	'0.566',	'-2.114',	'0.566',	'2.114',	'0.256',	'-1.805',	'0.566',	'1.239',	'0',	'-0.673',	'0.565',	'0.108',	'0.391',	'0',	'0.09',	'0.11',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-5.669',	'-0.971',	'4.783',	'-2.829',	'-1.954',	'3.8',	'2.84',	'-0.119',	'null',	'-3.8',	'0',	'0',	'null',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'-0.776',	'-0.257',	'-1.697',	'-0.177',	'-0.119',	'2.334',	'0.116',	'-0.024',	'null',	'0.2',	'0',	'0',	'0',	'0',	'null',	'-2.8',	'0',	'2.8',	'0',	'0.4',	'-3.6',	'0',	'3.6',	'0',	'-0.795',	'0.219',	'-0.277',	'-0.282',	'-1.682',	'-0.141',	'-0.042',	'null',	'2.786',	'0',	'0',	'0',	'3.814',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-1.954',	'-2.829',	'4.783',	'-0.971',	'-5.668',	'0',	'2.839',	'0',	'null',	'0',	'3.881',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-1.953',	'-2.829',	'4.782',	'-0.971',	'-5.669',	'0',	'2.841',	'0',	'null',	'-0.12',	'0',	'0',	'null',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'-0.27',	'-0.52',	'0',	'0',	'-2.02',	'0',	'2.02',	'0.19',	'null',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'-2.8',	'0',	'2.8',	'0',	'0.4',	'-3.6',	'0',	'3.6',	'0',	'-0.27',	'-0.52',	'0',	'-2.02',	'0',	'2.02',	'0',	'0',	'null',	'0',	'0.168',	'0.408',	'0',	'0',	'0',	'3.814',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-5.668',	'-0.971',	'4.782',	'-2.828',	'-1.954',	'3.8',	'2.839',	'-0.119',	'null',	'0',	'0.2',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-5.669',	'-0.971',	'4.783',	'-2.829',	'-1.954',	'3.8',	'2.84',	'-0.119',	'null',	'-3.8',	'0',	'0',	'null',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'-0.27',	'-0.52',	'0',	'0',	'-2.02',	'0',	'2.02',	'0.19',	'null',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'-2.8',	'0',	'2.8',	'0',	'0.4',	'-3.6',	'0',	'3.6',	'0',	'-0.27',	'-0.52',	'0',	'-2.02',	'0',	'2.02',	'0',	'0',	'null',	'0',	'0.168',	'0.408',	'0',	'0',	'0',	'3.814',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-1.954',	'-2.829',	'4.783',	'-0.971',	'-5.668',	'0',	'2.839',	'0',	'null',	'0',	'3.881',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-1.953',	'-2.829',	'4.782',	'-0.971',	'-5.669',	'0',	'2.841',	'0',	'null',	'-0.12',	'0',	'0',	'null',	'0',	'0',	'0',	'0',	'-1.488',	'-1.312',	'0',	'0',	'0',	'0',	'1.488',	'1.312',	'0.4',	'0',	'0',	'0',	'0',	'-3.6',	'0',	'0',	'0',	'0',	'3.6',	'-0.27',	'-0.52',	'0',	'0',	'0',	'0',	'-2.02',	'0',	'0',	'0',	'2.02',	'-0.11',	'0',	'-0.4',	'0',	'-0.4',	'0',	'-0.4',	'0',	'-0.4',	'0',	'0',	'null',	'0',	'1.918',	'0.368',	'0',	'0',	'0',	'3.814',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-5.668',	'-0.971',	'4.782',	'-2.828',	'-1.954',	'3.8',	'2.839',	'-0.119',	'null',	'0',	'0.2',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-5.669',	'-0.971',	'4.783',	'-2.829',	'-1.954',	'3.8',	'2.84',	'-0.119',	'null',	'-3.8',	'0',	'0',	'null',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'-0.27',	'-0.52',	'0',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0',	'-2.02',	'0',	'2.02',	'0.19',	'null',	'0.09',	'0.296',	'0',	'0',	'0',	'3.814',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-1.954',	'-2.829',	'4.783',	'-0.971',	'-5.668',	'0',	'2.839',	'0',	'null',	'0',	'3.881',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.211',	'-1.953',	'-2.829',	'4.782',	'-0.971',	'-5.669',	'0',	'2.841',	'0',	'null',	'-0.12',	'0',	'0',	'null',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'-0.27',	'-0.52',	'0',	'0',	'-2.02',	'0',	'2.02',	'-0.312',	'0.152',	'0',	'-0.717',	'-0.566',	'1.283',	'0',	'-1.702',	'0',	'1.702',	'0',	'-1.702',	'0',	'1.702',	'0',	'-1.702',	'0',	'1.702',	'0',	'-1.702',	'0',	'1.702',	'0',	'-1.702',	'0',	'1.702',	'0',	'-1.702',	'0',	'1.702',	'0',	'-1.702',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.701',	'0',	'-1.701',	'0',	'1.147',	'-0.565',	'-0.582',	'-0.348',	'null',	'-0.09',	'0.072',	'2.436',	'0.368',	'0',	'0',	'0',	'3.814',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.211',	'-5.668',	'-0.971',	'4.782',	'-2.828',	'-1.954',	'3.8',	'2.839',	'-0.119',	'null',	'0',	'0.2',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.27',	'-0.52',	'0',	'0',	'-6.02',	'0',	'6.02',	'0',	'-5.452',	'0',	'-0.369',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.406',	'0.41',	'0.155',	'0.41',	'0.156',	'0.41',	'0.156',	'0.41',	'0.155',	'0.41',	'0.156',	'0.41',	'0.156',	'0.41',	'0.155',	'0.41',	'0.156',	'0.689',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.16',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.411',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.411',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'0',	'5.505',	'0.072',	'-0.481',	'-0.123',	'-0.247',	'-0.515',	'-0.566',	'1.081',	'0',	'-1.646',	'-0.566',	'2.212',	'0',	'-2.778',	'-0.565',	'3.343',	'0',	'-3.909',	'-0.566',	'4.475',	'-0.16',	'-4.72',	'0',	'4.154',	'-0.565',	'-3.589',	'0',	'3.023',	'-0.566',	'-2.457',	'0',	'1.892',	'-0.566',	'-1.326',	'0',	'0.76',	'-0.565',	'-0.195',	'-0.759',	'null',	'-0.09',	'0.072',	'2.618',	'0',	'0',	'null',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'-0.27',	'-0.52',	'0',	'0',	'-2.02',	'0',	'2.02',	'0',	'-1.384',	'0',	'-0.437',	'0',	'1.003',	'0.566',	'-1.569',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0',	'1.62',	'0',	'-1.62',	'0.354',	'1.266',	'0',	'-0.7',	'0.565',	'0.135',	'0.391',	'null',	'0.09',	'0.296',	'0',	'0',	'0',	'3.814',	'null',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.27',	'-0.52',	'0',	'-6.02',	'0',	'6.02',	'0',	'-0.201',	'-0.369',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'-0.155',	'-0.41',	'-0.156',	'-0.41',	'-0.156',	'-0.41',	'-0.16',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.411',	'-0.411',	'0.689',	'0.156',	'0.41',	'0.155',	'0.41',	'0.156',	'0.41',	'0.156',	'0.41',	'0.155',	'0.411',	'0.155',	'0.41',	'0.156',	'0.41',	'0.155',	'0.411',	'0.405',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.41',	'-0.41',	'0.891',	'-0.072',	'-5.906',	'0',	'-0.123',	'0.885',	'-0.514',	'0',	'1.08',	'0.565',	'-1.645',	'0',	'2.211',	'0.566',	'-2.777',	'0',	'3.342',	'0.566',	'-3.908',	'0',	'4.474',	'0.405',	'-4.719',	'0.565',	'4.154',	'0',	'-3.588',	'0.566',	'3.022',	'0',	'-2.457',	'0.566',	'1.891',	'0',	'-1.325',	'0.566',	'0.759',	'0',	'-0.194',	'0',	'null',	'0',	'0',	'0.155',	'0',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-4.8',	'0',	'4.8',	'0.4',	'0',	'-5.6',	'0',	'5.6',	'-0.27',	'-0.52',	'0',	'0',	'-4.02',	'0',	'4.02',	'-0.161',	'-0.385',	'-0.566',	'0.951',	'0',	'-1.517',	'-0.565',	'2.082',	'0',	'-2.648',	'-0.566',	'3.214',	'-0.08',	'-3.62',	'0',	'3.055',	'-0.566',	'-2.489',	'0',	'1.923',	'-0.565',	'-1.358',	'0',	'0.792',	'-0.566',	'-0.226',	'-0.349',	'null',	'-0.09',	'0.072',	'4.618',	'0',	'0',	'0',	'0',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.52',	'0',	'-4.02',	'0',	'4.02',	'0',	'0',	'-4.228',	'-0.072',	'0.439',	'0.472',	'0.565',	'-1.037',	'0',	'1.603',	'0.566',	'-2.169',	'0',	'2.734',	'0.566',	'-3.3',	'0.165',	'3.536',	'0',	'-2.97',	'0.566',	'2.404',	'0',	'-1.839',	'0.566',	'1.273',	'0',	'-0.707',	'0.566',	'0.141',	'0.35',	'null',	'0',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-4.8',	'0',	'4.8',	'0.4',	'0',	'-5.6',	'0',	'5.6',	'-0.27',	'-0.52',	'0',	'0',	'-4.02',	'0',	'4.02',	'0',	'-3.715',	'0',	'-0.146',	'0',	'0.711',	'0.566',	'-1.277',	'0',	'1.843',	'0.565',	'-2.408',	'0',	'2.974',	'0.566',	'-3.54',	'0.405',	'3.295',	'0',	'-2.729',	'0.565',	'2.164',	'0',	'-1.598',	'0.566',	'1.032',	'0',	'-0.466',	'0',	'null',	'0',	'0.835',	'0.182',	'0',	'0',	'0',	'0',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.52',	'0',	'-4.02',	'0',	'4.02',	'0',	'-0.161',	'-0.145',	'-0.566',	'0.711',	'0',	'-1.277',	'-0.565',	'1.842',	'0',	'-2.408',	'-0.566',	'2.974',	'0',	'-3.54',	'-0.159',	'3.294',	'-0.566',	'-2.728',	'0',	'2.163',	'-0.566',	'-1.597',	'0',	'1.031',	'-0.565',	'-0.466',	'-0.35',	'null',	'0',	'-0.09',	'0.072',	'4.618',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-4.8',	'0',	'4.8',	'0.4',	'0',	'-5.6',	'0',	'5.6',	'-0.27',	'-0.52',	'0',	'0',	'-4.02',	'0',	'4.02',	'-0.161',	'-0.385',	'-0.566',	'0.951',	'0',	'-1.517',	'-0.565',	'2.082',	'0',	'-2.648',	'-0.566',	'3.214',	'-0.08',	'-3.62',	'0',	'3.055',	'-0.566',	'-2.489',	'0',	'1.923',	'-0.565',	'-1.358',	'0',	'0.792',	'-0.566',	'-0.226',	'-0.349',	'null',	'-0.09',	'0.072',	'4.618',	'0',	'0',	'0',	'0',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.52',	'0',	'-4.02',	'0',	'4.02',	'0',	'0',	'-4.228',	'-0.072',	'0.439',	'0.472',	'0.565',	'-1.037',	'0',	'1.603',	'0.566',	'-2.169',	'0',	'2.734',	'0.566',	'-3.3',	'0.165',	'3.536',	'0',	'-2.97',	'0.566',	'2.404',	'0',	'-1.839',	'0.566',	'1.273',	'0',	'-0.707',	'0.566',	'0.141',	'0.35',	'null',	'0',	'0.09',	'0.11',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-4.8',	'0',	'4.8',	'0.4',	'0',	'-5.6',	'0',	'5.6',	'-0.27',	'-0.52',	'0',	'0',	'-4.02',	'0',	'4.02',	'0',	'-3.715',	'0',	'-0.146',	'0',	'0.711',	'0.566',	'-1.277',	'0',	'1.843',	'0.565',	'-2.408',	'0',	'2.974',	'0.566',	'-3.54',	'0.405',	'3.295',	'0',	'-2.729',	'0.565',	'2.164',	'0',	'-1.598',	'0.566',	'1.032',	'0',	'-0.466',	'0',	'null',	'0',	'0.835',	'0.182',	'0',	'0',	'0',	'0',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.52',	'0',	'-4.02',	'0',	'4.02',	'0',	'-0.161',	'-0.145',	'-0.566',	'0.711',	'0',	'-1.277',	'-0.565',	'1.842',	'0',	'-2.408',	'-0.566',	'2.974',	'0',	'-3.54',	'-0.159',	'3.294',	'-0.566',	'-2.728',	'0',	'2.163',	'-0.566',	'-1.597',	'0',	'1.031',	'-0.565',	'-0.466',	'-0.35',	'null',	'0',	'-0.09',	'0.072',	'4.618',	'0',	'0',	'0',	'0',	'null',	'null',	'0',	'-4.8',	'0',	'4.8',	'0.4',	'0',	'-5.6',	'0',	'5.6',	'-0.27',	'-0.52',	'0',	'0',	'-4.02',	'0',	'4.02',	'-0.201',	'-0.306',	'-0.565',	'0.871',	'0',	'-1.437',	'-0.566',	'2.003',	'0',	'-2.568',	'-0.566',	'3.134',	'-0.079',	'-3.541',	'0',	'2.975',	'-0.566',	'-2.409',	'0',	'1.844',	'-0.566',	'-1.278',	'0',	'0.712',	'-0.565',	'-0.147',	'-0.389',	'null',	'-0.09',	'0.072',	'4.618',	'0',	'0',	'0',	'0',	'null',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.27',	'-0.52',	'0',	'-4.02',	'0',	'4.02',	'0',	'0',	'-3.43',	'0',	'-0.391',	'0',	'0.957',	'0.566',	'-1.523',	'0',	'2.088',	'0.566',	'-2.654',	'0',	'3.22',	'0.401',	'-3.455',	'0.565',	'2.89',	'0',	'-2.324',	'0.566',	'1.758',	'0',	'-1.193',	'0.566',	'0.627',	'0',	'-0.061',	'0'];
                relative_pos_z = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
            }*/
            if (nozzle_size === 0.4) {
                GStatus = ['null',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1'];
                EStatus = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                layerStatus = ['LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                relative_pos_x = ['null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-1.19',	'null',	'-5.22',	'0',	'5.22',	'0',	'null',	'-0.16',	'null',	'-0.215',	'-0.566',	'0.781',	'0',	'-1.346',	'-0.566',	'1.912',	'0',	'-2.478',	'-0.566',	'3.044',	'0',	'-3.609',	'-0.566',	'4.175',	'0',	'-4.741',	'-0.159',	'4.494',	'-0.566',	'-3.928',	'0',	'3.363',	'-0.566',	'-2.797',	'0',	'2.231',	'-0.565',	'-1.666',	'0',	'1.1',	'-0.566',	'-0.534',	'null',	'31.45',	'null',	'0',	'6',	'0',	'-6',	'-0.4',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'null',	'1.19',	'null',	'0',	'5.22',	'0',	'-5.22',	'0.373',	'-0.215',	'0',	'0.781',	'0.566',	'-1.347',	'0',	'1.912',	'0.566',	'-2.478',	'0',	'3.044',	'0.565',	'-3.609',	'0',	'4.175',	'0.566',	'-4.741',	'0.406',	'4.495',	'0',	'-3.929',	'0.566',	'3.363',	'0',	'-2.798',	'0.566',	'2.232',	'0',	'-1.666',	'0.565',	'1.101',	'0',	'-0.535',	'null',	'0',	'-30.914',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-1.19',	'null',	'-5.22',	'0',	'5.22',	'0',	'-0.614',	'0.454',	'0',	'-1.02',	'-0.565',	'1.585',	'0',	'-2.151',	'-0.566',	'2.717',	'0',	'-3.283',	'-0.565',	'3.848',	'0',	'-4.414',	'-0.486',	'4.821',	'-0.566',	'-4.255',	'0',	'3.689',	'-0.565',	'-3.124',	'0',	'2.558',	'-0.566',	'-1.992',	'0',	'1.427',	'-0.566',	'-0.861',	'0',	'0.295',	'null',	'31.155',	'null',	'0',	'6',	'0',	'-6',	'-0.4',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'null',	'1.19',	'null',	'0',	'5.22',	'0',	'-5.22',	'null',	'0.699',	'null',	'-0.541',	'0',	'1.106',	'0.566',	'-1.672',	'0',	'2.238',	'0.565',	'-2.803',	'0',	'3.369',	'0.566',	'-3.935',	'0',	'4.5',	'0.401',	'-4.735',	'0.565',	'4.17',	'0',	'-3.604',	'0.566',	'3.038',	'0',	'-2.472',	'0.565',	'1.907',	'0',	'-1.341',	'0.566',	'0.775',	'0',	'-0.21',	'null',	'0',	'-31.239',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-1.19',	'null',	'-5.22',	'0',	'5.22',	'0',	'null',	'-0.16',	'null',	'-0.215',	'-0.566',	'0.781',	'0',	'-1.346',	'-0.566',	'1.912',	'0',	'-2.478',	'-0.566',	'3.044',	'0',	'-3.609',	'-0.566',	'4.175',	'0',	'-4.741',	'-0.159',	'4.494',	'-0.566',	'-3.928',	'0',	'3.363',	'-0.566',	'-2.797',	'0',	'2.231',	'-0.565',	'-1.666',	'0',	'1.1',	'-0.566',	'-0.534',	'null',	'31.45',	'null',	'0',	'6',	'0',	'-6',	'-0.4',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'null',	'1.19',	'null',	'0',	'5.22',	'0',	'-5.22',	'0.373',	'-0.215',	'0',	'0.781',	'0.566',	'-1.347',	'0',	'1.912',	'0.566',	'-2.478',	'0',	'3.044',	'0.565',	'-3.609',	'0',	'4.175',	'0.566',	'-4.741',	'0.406',	'4.495',	'0',	'-3.929',	'0.566',	'3.363',	'0',	'-2.798',	'0.566',	'2.232',	'0',	'-1.666',	'0.565',	'1.101',	'0',	'-0.535',	'null',	'0',	'-5.07',	'null',	'null',	'0',	'6.156',	'0',	'-6.156',	'-0.4',	'0',	'6.956',	'0',	'-6.956',	'-0.4',	'0',	'7.756',	'0',	'-7.756',	'null',	'2.421',	'null',	'4.453',	'0.001',	'-4.07',	'null',	'-1.767',	'null',	'-0.158',	'null',	'5.908',	'null',	'-1.565',	'null',	'-30.173',	'null',	'-6.094',	'0',	'6.094',	'0',	'0.4',	'-6.894',	'0',	'6.894',	'0',	'0.4',	'-7.694',	'0',	'7.694',	'0',	'-1.146',	'-5.669',	'0.483',	'-0.483',	'0',	'5.933',	'null',	'0.001',	'null',	'-0.805',	'null',	'0',	'26.302',	'null',	'null',	'0',	'6.49',	'0',	'-6.49',	'-0.4',	'0',	'7.29',	'0',	'-7.29',	'-0.4',	'0',	'8.09',	'0',	'-8.09',	'null',	'3.306',	'null',	'3.902',	'0.001',	'-3.87',	'-1.42',	'-1.04',	'null',	'6.096',	'null',	'-1.565',	'null',	'-29.826',	'null',	'-6.294',	'0',	'6.294',	'0',	'0.4',	'-7.094',	'0',	'7.094',	'0',	'0.4',	'-7.894',	'0',	'7.894',	'0',	'-1.146',	'-5.84',	'0.307',	'-0.336',	'0',	'6.133',	'0.001',	'-1.152',	'null',	'0',	'26.116',	'null',	'null',	'0',	'6.823',	'0',	'-6.823',	'-0.4',	'0',	'7.623',	'0',	'-7.623',	'-0.4',	'0',	'8.423',	'0',	'-8.423',	'null',	'1.227',	'null',	'-0.348',	'null',	'3.303',	'null',	'3.359',	'0.001',	'-3.669',	'-1.076',	'-1.917',	'0',	'0.07',	'null',	'6.212',	'null',	'-1.565',	'null',	'-29.48',	'null',	'-6.494',	'0',	'6.494',	'0',	'0.4',	'-7.294',	'0',	'7.294',	'0',	'0.4',	'-8.094',	'0',	'8.094',	'0',	'-1.146',	'-5.841',	'-0.038',	'-0.19',	'null',	'0',	'null',	'6.333',	'0.001',	'-1.498',	'null',	'0',	'25.929',	'null',	'null',	'0',	'7.156',	'0',	'-7.156',	'-0.4',	'0',	'7.956',	'0',	'-7.956',	'-0.4',	'0',	'8.756',	'0',	'-8.756',	'null',	'1.76',	'null',	'-0.881',	'null',	'0',	'null',	'0.258',	'-0.257',	'2.794',	'0.73',	'3.471',	'null',	'0',	'null',	'-2.815',	'0.724',	'1.565',	'null',	'-30.699',	'null',	'-6.694',	'0',	'6.694',	'0',	'0.4',	'-7.494',	'0',	'7.494',	'0',	'0.4',	'-8.294',	'0',	'8.294',	'0',	'-1.148',	'-5.839',	'-0.384',	'-0.044',	'null',	'0',	'null',	'6.534',	'-0.279',	'-1.565',	'null',	'0',	'25.741',	'null',	'null',	'0',	'7.49',	'0',	'-7.49',	'-0.4',	'0',	'8.29',	'0',	'-8.29',	'-0.4',	'0',	'9.09',	'0',	'-9.09',	'null',	'2.295',	'null',	'-1.416',	'null',	'0',	'null',	'0.445',	'-0.445',	'3.679',	'0.381',	'3.27',	'null',	'0',	'null',	'-2.265',	'0.027',	'1.565',	'null',	'-30.352',	'null',	'-6.894',	'0',	'6.894',	'0',	'0.4',	'-7.694',	'0',	'7.694',	'0',	'0.4',	'-8.494',	'0',	'8.494',	'0',	'-1.146',	'-5.84',	'null',	'-0.629',	'null',	'6.734',	'-0.625',	'-1.565',	'null',	'0',	'25.554',	'null',	'null',	'0',	'7.823',	'0',	'-7.823',	'-0.4',	'0',	'8.623',	'0',	'-8.623',	'-0.4',	'0',	'9.423',	'0',	'-9.423',	'null',	'2.826',	'null',	'-1.947',	'null',	'0',	'null',	'0.632',	'-0.632',	'4.556',	'0.037',	'3.07',	'null',	'-0.001',	'null',	'-1.72',	'-0.663',	'1.565',	'null',	'-30.006',	'null',	'-7.094',	'0',	'7.094',	'0',	'0.4',	'-7.894',	'0',	'7.894',	'0',	'0.4',	'-8.694',	'0',	'8.694',	'0',	'-1.147',	'-5.84',	'null',	'-0.828',	'null',	'6.933',	'null',	'-0.97',	'null',	'-1.566',	'null',	'0',	'25.368',	'null',	'null',	'0',	'8.156',	'0',	'-8.156',	'-0.4',	'0',	'8.956',	'0',	'-8.956',	'-0.4',	'0',	'9.756',	'0',	'-9.756',	'null',	'3.361',	'null',	'-2.482',	'0',	'0.818',	'null',	'-0.817',	'null',	'5.437',	'-0.312',	'2.87',	'null',	'-0.001',	'null',	'-1.171',	'-1.359',	'1.565',	'null',	'-29.659',	'null',	'-7.294',	'0',	'7.294',	'0',	'0.4',	'-8.094',	'0',	'8.094',	'0',	'0.4',	'-8.894',	'0',	'8.894',	'0',	'-1.146',	'-5.84',	'null',	'-1.029',	'null',	'7.133',	'null',	'-1.317',	'null',	'-1.566',	'null',	'0',	'25.181',	'null',	'null',	'0',	'8.49',	'0',	'-8.49',	'-0.4',	'0',	'9.29',	'0',	'-9.29',	'-0.4',	'0',	'10.09',	'0',	'-10.09',	'null',	'0.879',	'null',	'1.006',	'null',	'-1.006',	'null',	'6.318',	'-0.658',	'2.67',	'null',	'-1.112',	'null',	'-1.565',	'null',	'2.05',	'null',	'0.626',	'null',	'-5.314',	'null',	'-3.015',	'null',	'-22.095',	'null',	'-7.494',	'0',	'7.494',	'0',	'0.4',	'-8.294',	'0',	'8.294',	'0',	'0.4',	'-9.094',	'0',	'9.094',	'0',	'-1.146',	'-5.841',	'null',	'-1.228',	'null',	'7.333',	'null',	'-1.663',	'null',	'-1.566',	'null',	'0',	'24.994',	'null',	'null',	'0',	'8.823',	'0',	'-8.823',	'-0.4',	'0',	'9.623',	'0',	'-9.623',	'-0.4',	'0',	'10.423',	'0',	'-10.423',	'null',	'0.879',	'null',	'1.192',	'null',	'-1.192',	'null',	'7.199',	'0.205',	'-1.565',	'null',	'-2.291',	'null',	'-3.548',	'null',	'6.194',	'null',	'2.469',	'null',	'-0.001',	'null',	'-0.077',	'null',	'-30.147',	'null',	'-7.694',	'0',	'7.694',	'0',	'0.4',	'-8.494',	'0',	'8.494',	'0',	'0.4',	'-9.294',	'0',	'9.294',	'0',	'-1.146',	'-5.84',	'null',	'-1.429',	'null',	'7.533',	'null',	'-2.01',	'null',	'-1.566',	'null',	'0',	'24.808',	'null',	'null',	'0',	'9.156',	'0',	'-9.156',	'-0.4',	'0',	'9.956',	'0',	'-9.956',	'-0.4',	'0',	'10.756',	'0',	'-10.756',	'null',	'0.879',	'null',	'1.379',	'null',	'-1.379',	'null',	'4.081',	'null',	'1.945',	'null',	'1.565',	'0.486',	'-8.076',	'null',	'6.725',	'null',	'2.27',	'null',	'-30.025',	'null',	'-7.894',	'0',	'7.894',	'0',	'0.4',	'-8.694',	'0',	'8.694',	'0',	'0.4',	'-9.494',	'0',	'9.494',	'0',	'-1.146',	'-5.841',	'null',	'3.748',	'null',	'-1.565',	'null',	'-3.81',	'null',	'7.732',	'null',	'0',	'20.698',	'null',	'null',	'0',	'9.49',	'0',	'-9.49',	'-0.4',	'0',	'10.29',	'0',	'-10.29',	'-0.4',	'0',	'11.09',	'0',	'-11.09',	'0.881',	'1.565',	'null',	'-1.567',	'null',	'4.614',	'null',	'1.6',	'null',	'1.565',	'-0.519',	'2.07',	'null',	'-0.375',	'null',	'-8.955',	'null',	'-20.495',	'null',	'-8.094',	'0',	'8.094',	'0',	'0.4',	'-8.894',	'0',	'8.894',	'0',	'0.4',	'-9.694',	'0',	'9.694',	'0',	'-1.147',	'-5.84',	'null',	'3.402',	'null',	'-1.564',	'null',	'-3.666',	'null',	'7.933',	'null',	'0',	'20.165',	'null',	'null',	'0',	'9.823',	'0',	'-9.823',	'-0.4',	'0',	'10.623',	'0',	'-10.623',	'-0.4',	'0',	'11.423',	'0',	'-11.423',	'1.067',	'1.565',	'null',	'-1.754',	'null',	'5.15',	'1.251',	'1.565',	'-0.171',	'1.869',	'null',	'-0.001',	'null',	'-9.662',	'null',	'-19.962',	'null',	'-8.294',	'0',	'8.294',	'0',	'0.4',	'-9.094',	'0',	'9.094',	'0',	'0.4',	'-9.894',	'0',	'9.894',	'0',	'-1.147',	'-5.839',	'null',	'3.054',	'null',	'-1.565',	'null',	'-3.518',	'null',	'8.133',	'null',	'0',	'19.632',	'null',	'null',	'0',	'10.156',	'0',	'-10.156',	'-0.4',	'0',	'10.956',	'0',	'-10.956',	'-0.4',	'0',	'11.756',	'0',	'-11.756',	'null',	'5.035',	'null',	'1.524',	'0.907',	'1.565',	'0.174',	'1.67',	'0',	'-5.839',	'-0.07',	'0',	'-3.776',	'0',	'3.776',	'null',	'-3.448',	'null',	'-0.169',	'0',	'0.735',	'0.566',	'-1.301',	'0',	'1.866',	'0.566',	'-2.432',	'0',	'2.998',	'0.457',	'-3.455',	'0',	'3.455',	'0',	'-3.455',	'0.361',	'3.094',	'0',	'-2.528',	'0.565',	'1.963',	'0',	'-1.397',	'0.566',	'0.831',	'0',	'-0.266',	'null',	'-23.088',	'null',	'-8.494',	'0',	'8.494',	'0',	'0.4',	'-9.294',	'0',	'9.294',	'0',	'0.4',	'-10.094',	'0',	'10.094',	'0',	'null',	'-3.375',	'null',	'-3.612',	'null',	'2.71',	'null',	'-1.565',	'null',	'-3.373',	'null',	'5.839',	'null',	'0.072',	'null',	'2.114',	'0',	'-2.114',	'0',	'0.16',	'0.352',	'0.566',	'-0.918',	'0',	'1.483',	'0.31',	'-1.793',	'0',	'1.793',	'0',	'-1.793',	'0',	'1.793',	'0',	'-1.793',	'0',	'1.793',	'0',	'-1.25',	'0.566',	'0.684',	'0',	'-0.119',	'null',	'0',	'19.686',	'null',	'null',	'0',	'10.49',	'0',	'-10.49',	'-0.4',	'0',	'11.29',	'0',	'-11.29',	'-0.4',	'0',	'12.09',	'0',	'-12.09',	'null',	'5.369',	'null',	'1.725',	'0.559',	'1.565',	'0.522',	'1.469',	'0',	'-5.839',	'null',	'-0.07',	'null',	'0',	'-4.11',	'0',	'4.11',	'-0.161',	'-0.591',	'-0.566',	'1.157',	'0',	'-1.723',	'-0.565',	'2.288',	'0',	'-2.854',	'-0.566',	'3.42',	'0',	'-3.791',	'0',	'3.791',	'-0.217',	'-3.574',	'0',	'3.008',	'-0.565',	'-2.443',	'0',	'1.877',	'-0.566',	'-1.311',	'0',	'0.745',	'-0.565',	'-0.18',	'null',	'-19.364',	'null',	'-8.694',	'0',	'8.694',	'0',	'0.4',	'-9.494',	'0',	'9.494',	'0',	'0.4',	'-10.294',	'0',	'10.294',	'0',	'null',	'-3.575',	'null',	'-3.411',	'null',	'2.362',	'null',	'-1.565',	'null',	'-3.226',	'null',	'5.839',	'null',	'0.072',	'null',	'2.314',	'0',	'-2.314',	'0',	'null',	'2.154',	'null',	'-0.081',	'-0.565',	'0.646',	'0',	'-1.212',	'-0.566',	'1.778',	'0',	'-1.994',	'0',	'1.994',	'0',	'-1.994',	'0',	'1.994',	'0',	'-1.994',	'0',	'1.722',	'-0.565',	'-1.157',	'0',	'0.591',	'null',	'0',	'20.436',	'null',	'null',	'0',	'10.823',	'0',	'-10.823',	'-0.4',	'0',	'11.623',	'0',	'-11.623',	'-0.4',	'0',	'12.423',	'0',	'-12.423',	'null',	'5.702',	'null',	'1.925',	'0.213',	'1.565',	'0.868',	'1.269',	'0',	'-5.839',	'null',	'-0.07',	'null',	'0',	'-4.443',	'0',	'4.443',	'null',	'-4.013',	'null',	'-0.271',	'0',	'0.837',	'0.566',	'-1.403',	'0',	'1.968',	'0.566',	'-2.534',	'0',	'3.1',	'0.565',	'-3.665',	'0',	'4.122',	'0',	'-4.122',	'0.462',	'3.66',	'0',	'-3.094',	'0.566',	'2.528',	'0',	'-1.963',	'0.566',	'1.397',	'0',	'-0.831',	'0.565',	'0.266',	'null',	'-22.954',	'null',	'-8.894',	'0',	'8.894',	'0',	'0.4',	'-9.694',	'0',	'9.694',	'0',	'0.4',	'-10.494',	'0',	'10.494',	'0',	'null',	'-3.775',	'null',	'-3.211',	'null',	'2.016',	'null',	'-1.565',	'null',	'-3.08',	'null',	'5.839',	'null',	'0.072',	'null',	'2.514',	'0',	'-2.514',	'0',	'0.16',	'0.352',	'0.566',	'-0.918',	'0',	'1.483',	'0.566',	'-2.049',	'0',	'2.193',	'0',	'-2.193',	'0',	'2.193',	'0',	'-2.193',	'0',	'2.193',	'0',	'-1.65',	'0.566',	'1.084',	'0',	'-0.519',	'null',	'0',	'-1.824',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.881',	'null',	'-3.01',	'null',	'1.668',	'null',	'-1.565',	'null',	'-2.749',	'null',	'-0.184',	'0',	'5.839',	'null',	'3.482',	'null',	'-0.8',	'0',	'0.8',	'0',	'0.4',	'-1.6',	'0',	'1.6',	'0',	'-0.827',	'0.026',	'0',	'0.106',	'null',	'-0.331',	'null',	'0.116',	'null',	'17.71',	'null',	'0',	'0.8',	'0',	'-0.8',	'-0.4',	'0',	'1.6',	'0',	'-1.6',	'0.573',	'0.22',	'0.005',	'0',	'0.016',	'0.142',	'null',	'4.844',	'null',	'0',	'6',	'0',	'-6',	'-0.4',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'null',	'2.87',	'null',	'1.565',	'1.215',	'1.069',	'0',	'-5.839',	'null',	'-0.001',	'null',	'2.125',	'null',	'0',	'-28.204',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.882',	'null',	'-5.839',	'0',	'0.383',	'null',	'2.404',	'null',	'1.565',	'-1.323',	'2.811',	'null',	'3.481',	'null',	'-0.8',	'0',	'0.8',	'0',	'0.4',	'-1.6',	'0',	'1.6',	'0',	'-0.73',	'0.154',	'-0.219',	'-0.006',	'0',	'-0.125',	'null',	'17.726',	'null',	'0',	'0.8',	'0',	'-0.8',	'-0.4',	'0',	'1.6',	'0',	'-1.6',	'0.855',	'0.142',	'-0.198',	'0',	'0',	'-0.075',	'null',	'5.076',	'null',	'0',	'6',	'0',	'-6',	'-0.4',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'null',	'2.724',	'null',	'1.565',	'null',	'1.561',	'null',	'0.869',	'0',	'-5.839',	'-0.001',	'2.325',	'null',	'0',	'-28.404',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.882',	'null',	'-5.839',	'0',	'0.582',	'null',	'2.059',	'null',	'1.565',	'-0.978',	'2.612',	'null',	'3.481',	'null',	'-0.8',	'0',	'0.8',	'0',	'0.4',	'-1.6',	'0',	'1.6',	'0',	'-0.827',	'0.026',	'0',	'0.106',	'null',	'-0.331',	'null',	'0.116',	'null',	'17.71',	'null',	'0',	'0.8',	'0',	'-0.8',	'-0.4',	'0',	'1.6',	'0',	'-1.6',	'0.573',	'0.22',	'0.005',	'0',	'0.016',	'0.142',	'null',	'4.844',	'null',	'0',	'6',	'0',	'-6',	'-0.4',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'null',	'2.578',	'null',	'1.565',	'null',	'1.906',	'null',	'0.67',	'-0.001',	'-5.839',	'0',	'2.524',	'null',	'0',	'-28.603',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.882',	'null',	'-5.839',	'0',	'0.783',	'null',	'1.711',	'null',	'1.565',	'-0.63',	'2.411',	'null',	'21.081',	'null',	'-18',	'0',	'18',	'0',	'0.4',	'-18.8',	'0',	'18.8',	'0',	'0.4',	'-19.6',	'0',	'19.6',	'0',	'null',	'-1.19',	'null',	'-17.22',	'0',	'17.22',	'0',	'-0.16',	'-16.9',	'0',	'16.9',	'null',	'5.55',	'null',	'0',	'6',	'0',	'-6',	'-0.4',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'null',	'2.431',	'null',	'1.565',	'null',	'2.254',	'null',	'0.469',	'0',	'-5.84',	'0',	'2.725',	'null',	'0',	'-28.804',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.882',	'null',	'-5.839',	'0',	'0.983',	'1.365',	'1.565',	'-0.284',	'2.211',	'null',	'21.081',	'null',	'-18',	'0',	'18',	'0',	'0.4',	'-18.8',	'0',	'18.8',	'0',	'0.4',	'-19.6',	'0',	'19.6',	'0',	'null',	'-1.19',	'null',	'-17.22',	'0',	'17.22',	'0',	'-0.161',	'-0.283',	'-0.566',	'0.849',	'-0.514',	'-0.9',	'-0.566',	'0.9',	'-0.566',	'-0.9',	'-0.565',	'0.9',	'-0.566',	'-0.9',	'-0.566',	'0.9',	'-0.565',	'-0.901',	'-0.565',	'0.9',	'-0.566',	'-0.9',	'-0.566',	'0.901',	'-0.566',	'-0.9',	'-0.566',	'0.9',	'-0.565',	'-0.901',	'-0.565',	'0.9',	'-0.566',	'-0.9',	'-0.566',	'0.9',	'-0.566',	'-0.899',	'-0.566',	'0.899',	'-0.565',	'-0.9',	'-0.565',	'0.899',	'-0.566',	'-0.899',	'-0.566',	'0.9',	'-0.566',	'-0.899',	'-0.566',	'0.899',	'-0.565',	'-0.9',	'-0.566',	'0.9',	'-0.566',	'-0.899',	'-0.566',	'0.9',	'-0.566',	'-0.546',	'null',	'22.451',	'null',	'0',	'6',	'0',	'-6',	'-0.4',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'null',	'2.285',	'null',	'1.565',	'null',	'2.599',	'null',	'0.27',	'-0.001',	'-5.839',	'0',	'2.924',	'null',	'0',	'-29.003',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.882',	'null',	'-5.839',	'0',	'1.183',	'1.018',	'1.565',	'0.063',	'2.011',	'null',	'21.081',	'null',	'-18',	'0',	'18',	'0',	'0.4',	'-18.8',	'0',	'18.8',	'0',	'0.4',	'-19.6',	'0',	'19.6',	'0',	'null',	'-1.19',	'null',	'-17.22',	'0',	'17.22',	'0',	'-0.161',	'-0.484',	'-0.566',	'0.902',	'-0.566',	'-0.901',	'-0.566',	'0.902',	'-0.566',	'-0.902',	'-0.565',	'0.901',	'-0.565',	'-0.902',	'-0.566',	'0.902',	'-0.566',	'-0.901',	'-0.566',	'0.902',	'-0.566',	'-0.902',	'-0.565',	'0.901',	'-0.566',	'-0.901',	'-0.566',	'0.902',	'-0.566',	'-0.901',	'-0.565',	'0.9',	'-0.565',	'-0.901',	'-0.566',	'0.901',	'-0.566',	'-0.9',	'-0.566',	'0.901',	'-0.566',	'-0.901',	'-0.566',	'0.901',	'-0.565',	'-0.901',	'-0.566',	'0.901',	'-0.566',	'-0.901',	'-0.565',	'0.901',	'-0.566',	'-0.901',	'-0.566',	'0.901',	'-0.565',	'-0.901',	'-0.566',	'0.901',	'-0.566',	'-0.346',	'null',	'22.45',	'null',	'0',	'6',	'0',	'-6',	'-0.4',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'null',	'2.138',	'null',	'1.565',	'null',	'2.947',	'null',	'0.069',	'-0.001',	'-5.839',	'0',	'3.125',	'null',	'0',	'-29.204',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.882',	'null',	'-5.839',	'0',	'1.383',	'0.672',	'1.565',	'0.409',	'1.811',	'null',	'21.081',	'null',	'-18',	'0',	'18',	'0',	'0.4',	'-18.8',	'0',	'18.8',	'0',	'0.4',	'-19.6',	'0',	'19.6',	'0',	'null',	'-1.19',	'null',	'-17.22',	'0',	'17.22',	'0',	'-0.161',	'-0.283',	'-0.566',	'0.849',	'-0.514',	'-0.9',	'-0.566',	'0.9',	'-0.566',	'-0.9',	'-0.565',	'0.9',	'-0.566',	'-0.9',	'-0.566',	'0.9',	'-0.565',	'-0.901',	'-0.565',	'0.9',	'-0.566',	'-0.9',	'-0.566',	'0.901',	'-0.566',	'-0.9',	'-0.566',	'0.9',	'-0.565',	'-0.901',	'-0.565',	'0.9',	'-0.566',	'-0.9',	'-0.566',	'0.9',	'-0.566',	'-0.899',	'-0.566',	'0.899',	'-0.565',	'-0.9',	'-0.565',	'0.899',	'-0.566',	'-0.899',	'-0.566',	'0.9',	'-0.566',	'-0.899',	'-0.566',	'0.899',	'-0.565',	'-0.9',	'-0.566',	'0.9',	'-0.566',	'-0.899',	'-0.566',	'0.9',	'-0.566',	'-0.546',	'null',	'22.451',	'null',	'0',	'6',	'0',	'-6',	'-0.4',	'0',	'6.8',	'0',	'-6.8',	'-0.4',	'0',	'7.6',	'0',	'-7.6',	'null',	'1.992',	'null',	'1.565',	'null',	'3.161',	'null',	'-5.839',	'0',	'3.325',	'null',	'0',	'-30.404',	'null',	'null',	'-4',	'0',	'4',	'0',	'0.4',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'null',	'-0.882',	'null',	'-2.065',	'-0.597',	'1.029',	'null',	'29.715',	'null',	'0',	'4',	'0',	'-4',	'-0.4',	'0',	'4.8',	'0',	'-4.8',	'-0.4',	'0',	'5.6',	'0',	'-5.6',	'1.114',	'1.029',	'null',	'-1.263',	'null',	'3.838',	'null',	'-2.315',	'null',	'-1.524',	'null',	'0',	'-28.079',	'null',	'null',	'-4',	'0',	'4',	'0',	'0.4',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'null',	'-0.882',	'null',	'-1.516',	'-1.293',	'1.029',	'null',	'29.862',	'null',	'0',	'4',	'0',	'-4',	'-0.4',	'0',	'4.8',	'0',	'-4.8',	'-0.4',	'0',	'5.6',	'0',	'-5.6',	'0.967',	'1.029',	'null',	'-1.116',	'null',	'3.838',	'null',	'-2.114',	'null',	'-1.725',	'null',	'0',	'-28.079',	'null',	'null',	'-4',	'0',	'4',	'0',	'0.4',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'null',	'-1.19',	'null',	'-3.22',	'0',	'3.22',	'0',	'-0.311',	'0.15',	'0',	'-0.716',	'-0.566',	'1.282',	'0',	'-1.847',	'-0.566',	'2.413',	'-0.078',	'-2.822',	'0',	'2.256',	'-0.566',	'-1.69',	'0',	'1.125',	'-0.566',	'-0.559',	'null',	'31.451',	'null',	'0',	'4',	'0',	'-4',	'-0.4',	'0',	'4.8',	'0',	'-4.8',	'-0.4',	'0',	'5.6',	'0',	'-5.6',	'null',	'1.19',	'null',	'0',	'3.22',	'0',	'-3.22',	'null',	'0.159',	'null',	'0.237',	'0.565',	'-0.802',	'0',	'1.368',	'0.566',	'-1.934',	'0',	'2.499',	'0.401',	'-2.735',	'0.565',	'2.17',	'0',	'-1.604',	'0.566',	'1.038',	'0',	'-0.473',	'null',	'0',	'-30.976',	'null',	'null',	'-4',	'0',	'4',	'0',	'0.4',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'null',	'-1.19',	'null',	'-3.22',	'0',	'3.22',	'0',	'null',	'-0.161',	'null',	'-0.476',	'-0.566',	'1.042',	'0',	'-1.608',	'-0.565',	'2.173',	'0',	'-2.739',	'-0.161',	'2.494',	'-0.565',	'-1.929',	'0',	'1.363',	'-0.566',	'-0.797',	'0',	'0.232',	'null',	'31.219',	'null',	'0',	'4',	'0',	'-4',	'-0.4',	'0',	'4.8',	'0',	'-4.8',	'-0.4',	'0',	'5.6',	'0',	'-5.6',	'null',	'1.19',	'null',	'0',	'3.22',	'0',	'-3.22',	'0.635',	'-0.476',	'0',	'1.042',	'0.566',	'-1.608',	'0',	'2.174',	'0.565',	'-2.739',	'0.406',	'2.494',	'0',	'-1.929',	'0.566',	'1.363',	'0',	'-0.797',	'0.565',	'0.232',	'null',	'0',	'-31.449',	'null',	'null',	'-4',	'0',	'4',	'0',	'0.4',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'null',	'-1.19',	'null',	'-3.22',	'0',	'3.22',	'0',	'-0.311',	'0.15',	'0',	'-0.716',	'-0.566',	'1.282',	'0',	'-1.847',	'-0.566',	'2.413',	'-0.078',	'-2.822',	'0',	'2.256',	'-0.566',	'-1.69',	'0',	'1.125',	'-0.566',	'-0.559',	'null',	'31.451',	'null',	'0',	'4',	'0',	'-4',	'-0.4',	'0',	'4.8',	'0',	'-4.8',	'-0.4',	'0',	'5.6',	'0',	'-5.6',	'null',	'1.19',	'null',	'0',	'3.22',	'0',	'-3.22',	'null',	'0.159',	'null',	'0.237',	'0.565',	'-0.802',	'0',	'1.368',	'0.566',	'-1.934',	'0',	'2.499',	'0.401',	'-2.735',	'0.565',	'2.17',	'0',	'-1.604',	'0.566',	'1.038',	'0',	'-0.473'];
                relative_pos_y = ['null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'null',	'-1.19',	'null',	'0',	'-5.22',	'0',	'5.22',	'null',	'-4.846',	'null',	'-0.215',	'0',	'0.78',	'0.566',	'-1.346',	'0',	'1.912',	'0.565',	'-2.477',	'0',	'3.043',	'0.566',	'-3.609',	'0',	'4.174',	'0.566',	'-4.74',	'0.405',	'4.495',	'0',	'-3.929',	'0.566',	'3.363',	'0',	'-2.797',	'0.565',	'2.232',	'0',	'-1.666',	'0.566',	'1.1',	'0',	'-0.535',	'null',	'1.086',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-1.19',	'null',	'-5.22',	'0',	'5.22',	'0',	'-0.16',	'-0.215',	'-0.566',	'0.781',	'0',	'-1.347',	'-0.565',	'1.912',	'0',	'-2.478',	'-0.566',	'3.044',	'0',	'-3.61',	'-0.565',	'4.175',	'0',	'-4.741',	'-0.16',	'4.495',	'-0.566',	'-3.929',	'0',	'3.363',	'-0.565',	'-2.798',	'0',	'2.232',	'-0.566',	'-1.666',	'0',	'1.101',	'-0.566',	'-0.535',	'null',	'0',	'5.451',	'null',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'null',	'-1.19',	'null',	'0',	'-5.22',	'0',	'5.22',	'-0.161',	'-0.454',	'-0.566',	'1.02',	'0',	'-1.585',	'-0.566',	'2.151',	'0',	'-2.717',	'-0.566',	'3.283',	'0',	'-3.848',	'-0.566',	'4.414',	'-0.079',	'-4.821',	'0',	'4.255',	'-0.566',	'-3.689',	'0',	'3.124',	'-0.566',	'-2.558',	'0',	'1.992',	'-0.565',	'-1.427',	'0',	'0.861',	'-0.566',	'-0.295',	'null',	'5.451',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-1.19',	'null',	'-5.22',	'0',	'5.22',	'0',	'null',	'-5.061',	'null',	'0.541',	'0.565',	'-1.106',	'0',	'1.672',	'0.566',	'-2.238',	'0',	'2.803',	'0.566',	'-3.369',	'0',	'3.935',	'0.565',	'-4.5',	'0.166',	'4.735',	'0',	'-4.17',	'0.566',	'3.604',	'0',	'-3.038',	'0.566',	'2.472',	'0',	'-1.907',	'0.566',	'1.341',	'0',	'-0.775',	'0.565',	'0.21',	'null',	'0',	'0.55',	'null',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'null',	'-1.19',	'null',	'0',	'-5.22',	'0',	'5.22',	'null',	'-4.846',	'null',	'-0.215',	'0',	'0.78',	'0.566',	'-1.346',	'0',	'1.912',	'0.565',	'-2.477',	'0',	'3.043',	'0.566',	'-3.609',	'0',	'4.174',	'0.566',	'-4.74',	'0.405',	'4.495',	'0',	'-3.929',	'0.566',	'3.363',	'0',	'-2.797',	'0.565',	'2.232',	'0',	'-1.666',	'0.566',	'1.1',	'0',	'-0.535',	'null',	'1.086',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-1.19',	'null',	'-5.22',	'0',	'5.22',	'0',	'-0.16',	'-0.215',	'-0.566',	'0.781',	'0',	'-1.347',	'-0.565',	'1.912',	'0',	'-2.478',	'-0.566',	'3.044',	'0',	'-3.61',	'-0.565',	'4.175',	'0',	'-4.741',	'-0.16',	'4.495',	'-0.566',	'-3.929',	'0',	'3.363',	'-0.565',	'-2.798',	'0',	'2.232',	'-0.566',	'-1.666',	'0',	'1.101',	'-0.566',	'-0.535',	'null',	'0',	'5.451',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.881',	'null',	'-1.193',	'-0.577',	'-4.07',	'null',	'-0.001',	'null',	'0.043',	'null',	'-0.043',	'null',	'5.841',	'null',	'0.081',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.881',	'-5.668',	'-0.172',	'1.8',	'0.563',	'-1.59',	'null',	'2.064',	'null',	'3.004',	'null',	'0',	'0.08',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.881',	'null',	'-1.046',	'-0.925',	'-3.869',	'0',	'0.279',	'null',	'-0.28',	'null',	'5.841',	'null',	'0.081',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.882',	'-5.839',	'0',	'1.252',	'1.258',	'-1.643',	'0.675',	'4.298',	'null',	'0',	'0.081',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.881',	'null',	'-0.348',	'null',	'0.348',	'null',	'-0.9',	'-1.27',	'-3.669',	'-0.001',	'0.513',	'-0.251',	'-0.262',	'null',	'-0.001',	'null',	'5.841',	'null',	'0.081',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.881',	'-5.841',	'0',	'0.708',	'null',	'1.949',	'null',	'-1.697',	'-0.707',	'5.589',	'null',	'0',	'0.08',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.88',	'null',	'-0.881',	'null',	'-3.998',	'null',	'-0.962',	'0.749',	'-0.749',	'0',	'3.471',	'null',	'1.615',	'null',	'0.754',	'0',	'-5.841',	'null',	'5.922',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.882',	'-5.839',	'-0.001',	'0.163',	'null',	'2.64',	'null',	'-1.751',	'-1.051',	'5.841',	'null',	'0',	'0.08',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.88',	'null',	'-1.416',	'null',	'-2.765',	'null',	'-1.661',	'0.987',	'-0.986',	'0',	'3.27',	'null',	'1.963',	'null',	'0.607',	'0',	'-5.841',	'null',	'5.922',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.881',	'-5.84',	'null',	'2.949',	'null',	'-1.804',	'-1.146',	'5.841',	'null',	'0',	'0.081',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.881',	'null',	'-1.947',	'null',	'-1.535',	'null',	'-2.358',	'1.221',	'-1.221',	'0.001',	'3.069',	'null',	'2.309',	'null',	'0.461',	'0.001',	'-5.841',	'null',	'5.921',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.881',	'-5.841',	'null',	'3.096',	'null',	'-1.858',	'null',	'-1.238',	'null',	'5.841',	'null',	'0',	'0.081',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.88',	'null',	'-2.482',	'-0.308',	'-3.051',	'null',	'1.457',	'null',	'-1.457',	'0',	'2.87',	'null',	'2.656',	'null',	'0.314',	'0.001',	'-5.841',	'null',	'5.921',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.882',	'-5.839',	'null',	'3.242',	'null',	'-1.911',	'null',	'-1.332',	'null',	'5.841',	'null',	'0',	'0.081',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-2.967',	'null',	'-3.755',	'null',	'1.693',	'null',	'-1.692',	'0',	'2.67',	'null',	'-2.67',	'null',	'5.84',	'null',	'0',	'null',	'-0.168',	'null',	'0.169',	'null',	'-3.015',	'null',	'3.095',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.881',	'-5.841',	'null',	'3.389',	'null',	'-1.965',	'null',	'-1.424',	'null',	'5.841',	'null',	'0',	'0.081',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-2.273',	'null',	'-4.449',	'null',	'1.93',	'null',	'-1.929',	'0',	'5.84',	'null',	'0',	'null',	'-3.548',	'null',	'-2.291',	'null',	'2.468',	'null',	'3.35',	'null',	'0.021',	'null',	'0.081',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.882',	'-5.839',	'null',	'3.535',	'null',	'-2.019',	'null',	'-1.517',	'null',	'5.841',	'null',	'0',	'0.081',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-1.576',	'null',	'-5.145',	'null',	'1.759',	'null',	'4.082',	'null',	'0',	'null',	'-5.842',	'0.001',	'2.164',	'null',	'-2.164',	'null',	'2.27',	'null',	'3.651',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.881',	'-5.841',	'null',	'0',	'null',	'5.841',	'null',	'-2.159',	'null',	'-2.072',	'null',	'0',	'4.312',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.881',	'-5.841',	'null',	'1.226',	'null',	'4.615',	'null',	'0',	'null',	'-5.841',	'0.002',	'2.069',	'null',	'-2.07',	'null',	'2.399',	'null',	'3.522',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.881',	'-5.84',	'null',	'0',	'null',	'5.84',	'null',	'-2.013',	'null',	'-2.126',	'null',	'0',	'4.22',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'-0.881',	'-5.841',	'null',	'0.693',	'null',	'5.149',	'-0.001',	'-5.841',	'0.002',	'1.869',	'null',	'-1.823',	'null',	'2.588',	'null',	'3.286',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'-0.882',	'-5.839',	'null',	'0',	'null',	'5.841',	'null',	'-1.867',	'null',	'-2.179',	'null',	'0',	'4.126',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-2.405',	'null',	'1.524',	'0',	'-5.841',	'0.002',	'1.669',	'-1.478',	'1.565',	'-1.446',	'5.22',	'0',	'-5.22',	'0',	'null',	'0.16',	'null',	'0.169',	'0.566',	'-0.735',	'0',	'1.3',	'0.566',	'-1.866',	'0',	'2.432',	'0.565',	'-2.997',	'0.108',	'3.455',	'0.566',	'-3.455',	'0.566',	'3.454',	'0.206',	'-3.095',	'0.566',	'2.529',	'0',	'-1.963',	'0.565',	'1.398',	'0',	'-0.832',	'0.566',	'0.266',	'null',	'0.55',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'null',	'-3.109',	'null',	'-3.612',	'null',	'-0.001',	'null',	'5.841',	'null',	'-1.72',	'null',	'-1.565',	'null',	'-2.244',	'null',	'0',	'5.22',	'0',	'-5.22',	'0.511',	'-0.352',	'0',	'0.917',	'0.566',	'-1.483',	'0.256',	'1.793',	'0.565',	'-1.793',	'0.566',	'1.793',	'0.566',	'-1.793',	'0.565',	'1.794',	'0.565',	'-1.793',	'0.566',	'1.25',	'0',	'-0.685',	'0.566',	'0.119',	'null',	'0',	'0.551',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-2.606',	'null',	'1.725',	'0',	'-5.841',	'0.002',	'1.468',	'-1.13',	'1.565',	'null',	'-1.593',	'null',	'5.22',	'0',	'-5.22',	'0',	'0.751',	'-0.591',	'0',	'1.157',	'0.566',	'-1.723',	'0',	'2.288',	'0.566',	'-2.854',	'0',	'3.42',	'0.565',	'-3.791',	'0.566',	'3.791',	'0.349',	'-3.574',	'0.566',	'3.008',	'0',	'-2.443',	'0.566',	'1.877',	'0',	'-1.311',	'0.565',	'0.746',	'0',	'-0.18',	'null',	'0.73',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'null',	'-3.31',	'null',	'-3.411',	'null',	'-0.001',	'null',	'5.841',	'null',	'-1.573',	'null',	'-1.565',	'null',	'-2.391',	'null',	'0',	'5.22',	'0',	'-5.22',	'null',	'0.239',	'null',	'-0.08',	'0',	'0.646',	'0.566',	'-1.212',	'0',	'1.777',	'0.566',	'-1.994',	'0.566',	'1.994',	'0.565',	'-1.994',	'0.566',	'1.994',	'0.566',	'-1.994',	'0.565',	'1.723',	'0',	'-1.157',	'0.566',	'0.591',	'null',	'0',	'0.551',	'null',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-2.806',	'null',	'1.925',	'0',	'-5.84',	'0.001',	'1.269',	'-0.785',	'1.565',	'null',	'-1.739',	'null',	'5.22',	'0',	'-5.22',	'0',	'null',	'0.159',	'null',	'0.272',	'0.566',	'-0.838',	'0',	'1.403',	'0.566',	'-1.969',	'0',	'2.535',	'0.565',	'-3.1',	'0',	'3.666',	'0.566',	'-4.123',	'0.566',	'4.122',	'0.104',	'-3.66',	'0.565',	'3.095',	'0',	'-2.529',	'0.566',	'1.963',	'0',	'-1.398',	'0.566',	'0.832',	'0',	'-0.266',	'null',	'0.816',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'null',	'-3.509',	'null',	'-3.212',	'null',	'-0.001',	'null',	'5.841',	'null',	'-1.427',	'null',	'-1.565',	'null',	'-2.537',	'null',	'0',	'5.22',	'0',	'-5.22',	'0.511',	'-0.352',	'0',	'0.917',	'0.566',	'-1.483',	'0',	'2.049',	'0.565',	'-2.193',	'0.566',	'2.193',	'0.566',	'-2.194',	'0.566',	'2.194',	'0.565',	'-2.193',	'0.565',	'1.651',	'0',	'-1.085',	'0.566',	'0.519',	'null',	'0',	'0.551',	'null',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'null',	'-3.71',	'null',	'-3.011',	'null',	'-0.001',	'null',	'5.841',	'null',	'-0.001',	'null',	'-0.183',	'-1.096',	'-1.565',	'null',	'-0.674',	'null',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'-0.776',	'-0.257',	'-1.697',	'-0.177',	'null',	'2.215',	'null',	'0.116',	'null',	'0.176',	'null',	'-2.8',	'0',	'2.8',	'0',	'0.4',	'-3.6',	'0',	'3.6',	'0',	'-0.795',	'0.219',	'-0.277',	'-0.282',	'-1.682',	'-0.141',	'null',	'6.158',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.881',	'null',	'-5.841',	'0.002',	'1.068',	'-0.437',	'1.565',	'null',	'1.518',	'null',	'2.125',	'null',	'0',	'0.081',	'null',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'null',	'-3.58',	'null',	'1.565',	'0.751',	'0.382',	'null',	'0.001',	'null',	'-5.841',	'0.001',	'2.812',	'null',	'-0.491',	'null',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'-0.576',	'-0.155',	'-0.064',	'-0.277',	'-1.697',	'-0.158',	'null',	'2.527',	'null',	'-2.8',	'0',	'2.8',	'0',	'0.4',	'-3.6',	'0',	'3.6',	'0',	'-0.743',	'0.141',	'-0.368',	'-0.282',	'-1.415',	'-0.208',	'null',	'6.075',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.88',	'null',	'-5.841',	'null',	'0.001',	'null',	'0.869',	'-0.092',	'1.565',	'1.172',	'2.325',	'null',	'0',	'0.081',	'null',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'null',	'-3.434',	'null',	'1.565',	'0.405',	'0.582',	'null',	'0.001',	'null',	'-5.841',	'0.001',	'2.612',	'null',	'-0.291',	'null',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'-0.776',	'-0.257',	'-1.697',	'-0.177',	'null',	'2.215',	'null',	'0.116',	'null',	'0.176',	'null',	'-2.8',	'0',	'2.8',	'0',	'0.4',	'-3.6',	'0',	'3.6',	'0',	'-0.795',	'0.219',	'-0.277',	'-0.282',	'-1.682',	'-0.141',	'null',	'6.158',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.88',	'null',	'-5.841',	'null',	'0.001',	'null',	'0.669',	'0.254',	'1.565',	'0.827',	'2.524',	'null',	'0',	'0.081',	'null',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'null',	'-3.287',	'null',	'1.565',	'0.058',	'0.782',	'null',	'0.001',	'null',	'-5.841',	'0.001',	'2.411',	'null',	'-0.49',	'null',	'0',	'-2',	'0',	'2',	'0.4',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'null',	'-1.19',	'null',	'0',	'-1.22',	'0',	'1.22',	'-0.51',	'0',	'-0.4',	'0',	'null',	'5.3',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.88',	'null',	'-5.841',	'null',	'0.001',	'null',	'0.469',	'0.601',	'1.565',	'0.479',	'2.725',	'null',	'0',	'0.081',	'null',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'null',	'-3.141',	'null',	'1.565',	'-0.288',	'0.982',	'0.002',	'-5.841',	'0',	'2.212',	'null',	'-0.291',	'null',	'0',	'-2',	'0',	'2',	'0.4',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'null',	'-1.19',	'null',	'0',	'-1.22',	'0',	'1.22',	'-0.778',	'-0.283',	'0',	'0.849',	'0.051',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.546',	'null',	'5.097',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.88',	'null',	'-5.841',	'null',	'0.001',	'null',	'0.269',	'0.947',	'1.565',	'0.133',	'2.925',	'null',	'0',	'0.081',	'null',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'null',	'-2.994',	'null',	'1.565',	'-0.636',	'1.183',	'0.001',	'-5.84',	'0',	'2.011',	'null',	'-0.09',	'null',	'0',	'-2',	'0',	'2',	'0.4',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'null',	'-1.19',	'null',	'0',	'-1.22',	'0',	'1.22',	'-0.643',	'0.483',	'0',	'-0.901',	'0',	'0.901',	'0',	'-0.901',	'0',	'0.901',	'0',	'-0.901',	'0',	'0.901',	'0',	'-0.901',	'0',	'0.901',	'0',	'-0.901',	'0',	'0.901',	'0',	'-0.901',	'0',	'0.901',	'0',	'-0.901',	'0',	'0.901',	'-0.001',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.346',	'null',	'5.105',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.88',	'null',	'-5.841',	'null',	'0.001',	'null',	'0.068',	'1.295',	'1.565',	'-0.214',	'3.125',	'null',	'0',	'0.081',	'null',	'null',	'0',	'-6',	'0',	'6',	'0.4',	'0',	'-6.8',	'0',	'6.8',	'0.4',	'0',	'-7.6',	'0',	'7.6',	'null',	'-2.848',	'null',	'1.565',	'-0.981',	'1.382',	'0.001',	'-5.841',	'0.001',	'1.812',	'null',	'0.109',	'null',	'0',	'-2',	'0',	'2',	'0.4',	'0',	'-2.8',	'0',	'2.8',	'0.4',	'0',	'-3.6',	'0',	'3.6',	'null',	'-1.19',	'null',	'0',	'-1.22',	'0',	'1.22',	'-0.778',	'-0.283',	'0',	'0.849',	'0.051',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.9',	'0',	'0.9',	'0',	'-0.546',	'null',	'5.097',	'null',	'-6',	'0',	'6',	'0',	'0.4',	'-6.8',	'0',	'6.8',	'0',	'0.4',	'-7.6',	'0',	'7.6',	'0',	'null',	'-0.881',	'null',	'-5.841',	'null',	'1.511',	'null',	'1.565',	'-0.56',	'3.325',	'null',	'0',	'-0.919',	'null',	'null',	'0',	'-4',	'0',	'4',	'0.4',	'0',	'-4.8',	'0',	'4.8',	'0.4',	'0',	'-5.6',	'0',	'5.6',	'null',	'-1.434',	'null',	'0.553',	'0',	'-3.84',	'null',	'3.921',	'null',	'-4',	'0',	'4',	'0',	'0.4',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.88',	'-3.842',	'null',	'1.954',	'null',	'-1.029',	'null',	'2.916',	'null',	'-1.524',	'null',	'0',	'1.605',	'null',	'null',	'0',	'-4',	'0',	'4',	'0.4',	'0',	'-4.8',	'0',	'4.8',	'0.4',	'0',	'-5.6',	'0',	'5.6',	'null',	'-1.287',	'null',	'0.406',	'0',	'-3.84',	'null',	'3.921',	'null',	'-4',	'0',	'4',	'0',	'0.4',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'-0.88',	'-3.842',	'null',	'2.101',	'null',	'-1.029',	'null',	'2.769',	'null',	'-1.725',	'null',	'0',	'1.806',	'null',	'null',	'0',	'-4',	'0',	'4',	'0.4',	'0',	'-4.8',	'0',	'4.8',	'0.4',	'0',	'-5.6',	'0',	'5.6',	'null',	'-1.19',	'null',	'0',	'-3.22',	'0',	'3.22',	'-0.161',	'-0.151',	'-0.565',	'0.716',	'0',	'-1.282',	'-0.566',	'1.848',	'0',	'-2.413',	'-0.488',	'2.822',	'-0.566',	'-2.256',	'0',	'1.69',	'-0.565',	'-1.125',	'0',	'0.559',	'null',	'2.893',	'null',	'-4',	'0',	'4',	'0',	'0.4',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'null',	'-1.19',	'null',	'-3.22',	'0',	'3.22',	'0',	'null',	'-2.824',	'null',	'-0.237',	'0',	'0.803',	'0.565',	'-1.368',	'0',	'1.934',	'0.566',	'-2.5',	'0.166',	'2.735',	'0',	'-2.17',	'0.566',	'1.604',	'0',	'-1.038',	'0.565',	'0.473',	'null',	'0',	'0.55',	'null',	'null',	'0',	'-4',	'0',	'4',	'0.4',	'0',	'-4.8',	'0',	'4.8',	'0.4',	'0',	'-5.6',	'0',	'5.6',	'null',	'-1.19',	'null',	'0',	'-3.22',	'0',	'3.22',	'null',	'-2.584',	'null',	'-0.477',	'0',	'1.042',	'0.566',	'-1.608',	'0',	'2.174',	'0.565',	'-2.739',	'0.405',	'2.494',	'0',	'-1.928',	'0.566',	'1.362',	'0',	'-0.797',	'0.566',	'0.231',	'null',	'0.552',	'null',	'-4',	'0',	'4',	'0',	'0.4',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'null',	'-1.19',	'null',	'-3.22',	'0',	'3.22',	'0',	'-0.161',	'-0.477',	'-0.565',	'1.042',	'0',	'-1.608',	'-0.566',	'2.174',	'0',	'-2.739',	'-0.16',	'2.494',	'-0.566',	'-1.928',	'0',	'1.362',	'-0.565',	'-0.797',	'0',	'0.231',	'null',	'0',	'3.219',	'null',	'null',	'0',	'-4',	'0',	'4',	'0.4',	'0',	'-4.8',	'0',	'4.8',	'0.4',	'0',	'-5.6',	'0',	'5.6',	'null',	'-1.19',	'null',	'0',	'-3.22',	'0',	'3.22',	'-0.161',	'-0.151',	'-0.565',	'0.716',	'0',	'-1.282',	'-0.566',	'1.848',	'0',	'-2.413',	'-0.488',	'2.822',	'-0.566',	'-2.256',	'0',	'1.69',	'-0.565',	'-1.125',	'0',	'0.559',	'null',	'2.893',	'null',	'-4',	'0',	'4',	'0',	'0.4',	'-4.8',	'0',	'4.8',	'0',	'0.4',	'-5.6',	'0',	'5.6',	'0',	'null',	'-1.19',	'null',	'-3.22',	'0',	'3.22',	'0',	'null',	'-2.824',	'null',	'-0.237',	'0',	'0.803',	'0.565',	'-1.368',	'0',	'1.934',	'0.566',	'-2.5',	'0.166',	'2.735',	'0',	'-2.17',	'0.566',	'1.604',	'0',	'-1.038',	'0.565',	'0.473'];
                relative_pos_z = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.2',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
            }
            if (nozzle_size === 0.6) {
                GStatus = ['null',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1'];
                EStatus = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                layerStatus = ['LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                relative_pos_x = ['null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-1.19',	'null',	'-5.02',	'0',	'5.02',	'0',	'null',	'-0.24',	'null',	'-0.42',	'-0.849',	'1.269',	'0',	'-2.118',	'-0.848',	'2.966',	'0',	'-3.815',	'-0.725',	'4.417',	'-0.849',	'-3.568',	'0',	'2.719',	'-0.848',	'-1.871',	'0',	'1.022',	'-0.848',	'-0.174',	'null',	'31.17',	'null',	'0',	'6.2',	'0',	'-6.2',	'-0.6',	'0',	'7.4',	'0',	'-7.4',	'null',	'1.19',	'null',	'0',	'5.02',	'0',	'-5.02',	'0.659',	'-0.42',	'0',	'1.268',	'0.849',	'-2.117',	'0',	'2.965',	'0.849',	'-3.814',	'0.123',	'4.417',	'0',	'-3.569',	'0.849',	'2.72',	'0',	'-1.872',	'0.849',	'1.023',	'0',	'-0.175',	'null',	'0',	'-30.994',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-1.19',	'null',	'-5.02',	'0',	'5.02',	'0',	'-0.617',	'0.377',	'0',	'-1.225',	'-0.849',	'2.074',	'0',	'-2.922',	'-0.849',	'3.771',	'-0.08',	'-4.46',	'0',	'3.612',	'-0.849',	'-2.763',	'0',	'1.915',	'-0.849',	'-1.066',	'0',	'0.218',	'null',	'30.952',	'null',	'0',	'6.2',	'0',	'-6.2',	'-0.6',	'0',	'7.4',	'0',	'-7.4',	'null',	'1.19',	'null',	'0',	'5.02',	'0',	'-5.02',	'null',	'0.701',	'null',	'-0.462',	'0',	'1.311',	'0.848',	'-2.159',	'0',	'3.008',	'0.848',	'-3.856',	'0.164',	'4.375',	'0',	'-3.526',	'0.848',	'2.678',	'0',	'-1.829',	'0.848',	'0.981',	'0',	'-0.132',	'null',	'0',	'-5.476',	'null',	'null',	'0',	'6.44',	'0',	'-6.44',	'-0.6',	'0',	'7.64',	'0',	'-7.64',	'null',	'4.547',	'null',	'-3.828',	'null',	'0',	'null',	'0.8',	'null',	'5.195',	'null',	'-1.597',	'null',	'-29.933',	'null',	'-6.344',	'0',	'6.344',	'0',	'0.6',	'-7.544',	'0',	'7.544',	'0',	'null',	'-0.72',	'null',	'-1.934',	'null',	'-3.686',	'null',	'-0.485',	'null',	'0',	'31.141',	'null',	'null',	'0',	'6.94',	'0',	'-6.94',	'-0.6',	'0',	'8.14',	'0',	'-8.14',	'null',	'5.346',	'null',	'-4.627',	'0',	'2.118',	'null',	'4.158',	'null',	'-1.598',	'null',	'-29.413',	'null',	'-6.644',	'0',	'6.644',	'0',	'0.6',	'-7.844',	'0',	'7.844',	'0',	'null',	'-0.72',	'null',	'-1.934',	'null',	'-4.205',	'null',	'-0.266',	'null',	'0',	'30.641',	'null',	'null',	'0',	'7.44',	'0',	'-7.44',	'-0.6',	'0',	'8.64',	'0',	'-8.64',	'null',	'5.678',	'null',	'1.597',	'null',	'-3.118',	'null',	'-3.438',	'-0.001',	'5.428',	'null',	'-29.362',	'null',	'-6.944',	'0',	'6.944',	'0',	'0.6',	'-8.144',	'0',	'8.144',	'0',	'null',	'-0.721',	'null',	'-1.933',	'null',	'-4.724',	'null',	'-0.047',	'null',	'0',	'30.141',	'null',	'null',	'0',	'7.94',	'0',	'-7.94',	'-0.6',	'0',	'9.14',	'0',	'-9.14',	'null',	'0.719',	'null',	'4.756',	'null',	'2.081',	'null',	'-1.597',	'0.988',	'-5.961',	'null',	'-23.402',	'null',	'-7.244',	'0',	'7.244',	'0',	'0.6',	'-8.444',	'0',	'8.444',	'0',	'null',	'-0.721',	'null',	'-1.933',	'null',	'-4.826',	'null',	'-0.244',	'null',	'0',	'29.64',	'null',	'null',	'0',	'8.44',	'0',	'-8.44',	'-0.6',	'0',	'9.64',	'0',	'-9.64',	'null',	'0.72',	'null',	'6.074',	'1.042',	'-1.597',	'null',	'1.507',	'null',	'-5.96',	'null',	'-23.402',	'null',	'-7.544',	'0',	'7.544',	'0',	'0.6',	'-8.744',	'0',	'8.744',	'0',	'null',	'-0.72',	'null',	'-1.934',	'null',	'-4.309',	'null',	'-1.061',	'null',	'0',	'29.14',	'null',	'null',	'0',	'8.94',	'0',	'-8.94',	'-0.6',	'0',	'10.14',	'0',	'-10.14',	'null',	'0.719',	'null',	'7.398',	'-0.001',	'-1.597',	'null',	'2.029',	'null',	'-5.961',	'null',	'-23.403',	'null',	'-7.844',	'0',	'7.844',	'0',	'0.6',	'-9.044',	'0',	'9.044',	'0',	'-1.218',	'0.497',	'null',	'0',	'null',	'-1.932',	'null',	'-3.786',	'null',	'-1.885',	'null',	'0',	'28.64',	'null',	'null',	'0',	'9.44',	'0',	'-9.44',	'-0.6',	'0',	'10.64',	'0',	'-10.64',	'null',	'3.96',	'null',	'5.476',	'-1.04',	'-1.597',	'null',	'2.548',	'null',	'-5.388',	'-0.109',	'0',	'-2.66',	'0',	'2.66',	'-0.241',	'-0.514',	'-0.849',	'1.363',	'0',	'-2.18',	'0',	'2.18',	'0',	'-2.18',	'0',	'1.963',	'-0.849',	'-1.114',	'0',	'0.266',	'null',	'-21.711',	'null',	'-8.144',	'0',	'8.144',	'0',	'0.6',	'-9.344',	'0',	'9.344',	'0',	'null',	'-5.921',	'null',	'-2.703',	'null',	'6.07',	'null',	'1.364',	'0',	'-1.364',	'0',	'1.124',	'-0.667',	'-0.218',	'0.885',	'0',	'-0.885',	'0',	'0.885',	'0',	'-0.885',	'0',	'0.515',	'null',	'0',	'21.316',	'null',	'null',	'0',	'9.94',	'0',	'-9.94',	'-0.6',	'0',	'11.14',	'0',	'-11.14',	'null',	'4.459',	'null',	'5.959',	'null',	'-1.741',	'null',	'-1.597',	'null',	'3.067',	'null',	'-5.688',	'-0.109',	'0',	'-3.16',	'0',	'3.16',	'null',	'-2.921',	'null',	'0.809',	'0.848',	'-1.657',	'0',	'2.506',	'0.174',	'-2.68',	'0',	'2.68',	'0',	'-2.17',	'0.849',	'1.321',	'0',	'-0.473',	'null',	'-22.852',	'null',	'-8.444',	'0',	'8.444',	'0',	'0.6',	'-9.644',	'0',	'9.644',	'0',	'null',	'-5.402',	'null',	'-3.522',	'null',	'6.07',	'null',	'1.664',	'0',	'-1.664',	'0',	'0.239',	'0.559',	'0.626',	'-1.185',	'0',	'1.185',	'0',	'-1.185',	'0',	'1.185',	'0',	'-0.924',	'null',	'0',	'21.07',	'null',	'null',	'0',	'10.44',	'0',	'-10.44',	'-0.6',	'0',	'11.64',	'0',	'-11.64',	'null',	'4.959',	'null',	'5.959',	'null',	'-1.961',	'null',	'-1.597',	'null',	'3.559',	'null',	'-5.932',	'-0.137',	'0',	'-3.66',	'0',	'3.66',	'-0.241',	'-0.514',	'-0.849',	'1.363',	'0',	'-2.211',	'-0.849',	'3.06',	'0',	'-3.18',	'0',	'2.963',	'-0.849',	'-2.114',	'0',	'1.266',	'-0.849',	'-0.417',	'null',	'-19.845',	'null',	'-8.744',	'0',	'8.744',	'0',	'0.6',	'-9.944',	'0',	'9.944',	'0',	'null',	'-4.884',	'null',	'-4.341',	'null',	'6.071',	'null',	'1.964',	'0',	'-1.964',	'0',	'null',	'1.724',	'null',	'-0.419',	'-0.848',	'1.267',	'0',	'-1.485',	'0',	'1.485',	'0',	'-1.485',	'0',	'1.363',	'-0.848',	'-0.515',	'null',	'0',	'20.831',	'null',	'null',	'0',	'10.94',	'0',	'-10.94',	'-0.6',	'0',	'12.14',	'0',	'-12.14',	'null',	'5.459',	'null',	'5.96',	'null',	'-2.181',	'null',	'-1.597',	'null',	'3.778',	'null',	'-5.632',	'-0.437',	'0',	'-4.16',	'0',	'4.16',	'null',	'-3.921',	'null',	'0.112',	'0.848',	'-0.96',	'0',	'1.809',	'0.848',	'-2.657',	'0',	'3.506',	'0.174',	'-3.68',	'0.662',	'3.018',	'0',	'-2.17',	'0.849',	'1.321',	'0',	'-0.473',	'null',	'-22.252',	'null',	'-9.044',	'0',	'9.044',	'0',	'0.6',	'-10.244',	'0',	'10.244',	'0',	'null',	'-4.365',	'null',	'-5.16',	'null',	'0',	'null',	'0.103',	'null',	'5.968',	'null',	'0',	'2.264',	'0',	'-2.264',	'1.348',	'0.676',	'0',	'-1.524',	'-0.261',	'1.785',	'0',	'-1.785',	'0',	'1.785',	'-0.377',	'-1.408',	'0',	'0.559',	'null',	'0',	'-0.788',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-6.278',	'null',	'-0.403',	'null',	'0.001',	'null',	'5.958',	'null',	'3.122',	'null',	'-0.2',	'0',	'0.2',	'0',	'0.6',	'-1.4',	'0',	'1.4',	'0',	'null',	'17.2',	'null',	'0',	'0.2',	'0',	'-0.2',	'-0.6',	'0',	'1.4',	'0',	'-1.4',	'null',	'5.6',	'null',	'0',	'6.2',	'0',	'-6.2',	'-0.6',	'0',	'7.4',	'0',	'-7.4',	'null',	'2.681',	'null',	'1.597',	'null',	'2.401',	'null',	'-5.959',	'null',	'0.627',	'null',	'5.332',	'null',	'0',	'-31.879',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'-0.891',	'0.17',	'null',	'-0.001',	'null',	'-5.958',	'null',	'-0.001',	'null',	'0.702',	'null',	'8.379',	'null',	'-0.2',	'0',	'0.2',	'0',	'0.6',	'-1.4',	'0',	'1.4',	'0',	'null',	'17.2',	'null',	'0',	'0.2',	'0',	'-0.2',	'-0.6',	'0',	'1.4',	'0',	'-1.4',	'null',	'5.6',	'null',	'0',	'6.2',	'0',	'-6.2',	'-0.6',	'0',	'7.4',	'0',	'-7.4',	'null',	'2.462',	'null',	'1.597',	'null',	'-2.413',	'null',	'5.033',	'null',	'-0.001',	'null',	'-5.958',	'null',	'0',	'-25.92',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'-1.11',	'0.389',	'null',	'-0.001',	'null',	'-5.958',	'null',	'-0.001',	'null',	'1.002',	'null',	'26.079',	'null',	'-18.2',	'0',	'18.2',	'0',	'0.6',	'-19.4',	'0',	'19.4',	'0',	'null',	'-1.19',	'null',	'-17.02',	'0',	'17.02',	'0',	'null',	'5.39',	'null',	'0',	'6.2',	'0',	'-6.2',	'-0.6',	'0',	'7.4',	'0',	'-7.4',	'null',	'2.242',	'null',	'1.598',	'null',	'-1.894',	'null',	'4.733',	'null',	'-0.001',	'null',	'-5.959',	'null',	'0',	'-25.919',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-1.331',	'null',	'0.61',	'null',	'0',	'null',	'-5.959',	'null',	'-0.001',	'null',	'1.303',	'null',	'25.778',	'null',	'-18.2',	'0',	'18.2',	'0',	'0.6',	'-19.4',	'0',	'19.4',	'0',	'null',	'-1.19',	'null',	'-17.02',	'0',	'17.02',	'0',	'-0.242',	'-0.405',	'-0.308',	'-0.541',	'-0.308',	'-0.54',	'-0.308',	'-0.541',	'-0.308',	'-0.541',	'-0.307',	'-0.541',	'-0.308',	'-0.541',	'-0.307',	'-0.541',	'-0.308',	'-0.541',	'-0.307',	'-0.541',	'-0.308',	'-0.54',	'-0.308',	'-0.54',	'-0.309',	'-0.54',	'-0.308',	'-0.541',	'-0.308',	'-0.54',	'-0.308',	'-0.541',	'-0.308',	'-0.54',	'-0.308',	'-0.541',	'-0.308',	'-0.54',	'-0.308',	'-0.541',	'null',	'22.159',	'null',	'0',	'6.2',	'0',	'-6.2',	'-0.6',	'0',	'7.4',	'0',	'-7.4',	'null',	'2.022',	'null',	'1.597',	'-1.372',	'4.432',	'null',	'-0.001',	'null',	'-5.959',	'null',	'0',	'-25.919',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-1.19',	'null',	'-5.02',	'0',	'5.02',	'0',	'null',	'-0.24',	'null',	'-0.42',	'-0.849',	'1.269',	'0',	'-2.118',	'-0.848',	'2.966',	'0',	'-3.815',	'-0.725',	'4.417',	'-0.849',	'-3.568',	'0',	'2.719',	'-0.848',	'-1.871',	'0',	'1.022',	'-0.848',	'-0.174',	'null',	'26.37',	'null',	'-18.2',	'0',	'18.2',	'0',	'0.6',	'-19.4',	'0',	'19.4',	'0',	'null',	'-1.19',	'null',	'-17.02',	'0',	'17.02',	'0',	'-0.242',	'-0.205',	'-0.309',	'-0.539',	'-0.309',	'-0.54',	'-0.309',	'-0.539',	'-0.309',	'-0.54',	'-0.309',	'-0.539',	'-0.309',	'-0.54',	'-0.309',	'-0.539',	'-0.309',	'-0.54',	'-0.309',	'-0.539',	'-0.309',	'-0.54',	'-0.31',	'-0.538',	'-0.31',	'-0.539',	'-0.31',	'-0.538',	'-0.31',	'-0.539',	'-0.31',	'-0.538',	'-0.31',	'-0.539',	'-0.31',	'-0.539',	'-0.309',	'-0.539',	'-0.31',	'-0.539',	'null',	'21.959',	'null',	'0',	'6.2',	'0',	'-6.2',	'-0.6',	'0',	'7.4',	'0',	'-7.4',	'null',	'1.19',	'null',	'0',	'5.02',	'0',	'-5.02',	'0.659',	'-0.42',	'0',	'1.268',	'0.849',	'-2.117',	'0',	'2.965',	'0.849',	'-3.814',	'0.123',	'4.417',	'0',	'-3.569',	'0.849',	'2.72',	'0',	'-1.872',	'0.849',	'1.023',	'0',	'-0.175',	'null',	'0',	'-31.994',	'null',	'null',	'-4.2',	'0',	'4.2',	'0',	'0.6',	'-5.4',	'0',	'5.4',	'0',	'null',	'-1.19',	'null',	'-3.02',	'0',	'3.02',	'0',	'-1.162',	'0.922',	'0',	'-1.771',	'-0.769',	'2.46',	'-0.848',	'-1.612',	'0',	'0.763',	'null',	'30.407',	'null',	'0',	'4.2',	'0',	'-4.2',	'-0.6',	'0',	'5.4',	'0',	'-5.4',	'null',	'1.19',	'null',	'0',	'3.02',	'0',	'-3.02',	'null',	'0.398',	'null',	'-0.16',	'0',	'1.009',	'0.848',	'-1.857',	'0.166',	'2.374',	'0',	'-1.526',	'0.849',	'0.677',	'null',	'0',	'-31.168',	'null',	'null',	'-4.2',	'0',	'4.2',	'0',	'0.6',	'-5.4',	'0',	'5.4',	'0',	'null',	'-1.19',	'null',	'-3.02',	'0',	'3.02',	'0',	'null',	'-0.24',	'null',	'-0.118',	'-0.848',	'0.966',	'0',	'-1.815',	'-0.725',	'2.417',	'-0.849',	'-1.568',	'0',	'0.72',	'null',	'30.45',	'null',	'0',	'4.2',	'0',	'-4.2',	'-0.6',	'0',	'5.4',	'0',	'-5.4',	'null',	'1.19',	'null',	'0',	'3.02',	'0',	'-3.02',	'0.356',	'-0.118',	'0',	'0.966',	'0.849',	'-1.815',	'0.124',	'2.416',	'0',	'-1.568',	'0.849',	'0.719',	'null',	'0',	'-31.168',	'null',	'null',	'-4.2',	'0',	'4.2',	'0',	'0.6',	'-5.4',	'0',	'5.4',	'0',	'null',	'-1.19',	'null',	'-3.02',	'0',	'3.02',	'0',	'-1.162',	'0.922',	'0',	'-1.771',	'-0.769',	'2.46',	'-0.848',	'-1.612',	'0',	'0.763',	'null',	'30.407',	'null',	'0',	'4.2',	'0',	'-4.2',	'-0.6',	'0',	'5.4',	'0',	'-5.4',	'null',	'1.19',	'null',	'0',	'3.02',	'0',	'-3.02',	'null',	'0.398',	'null',	'-0.16',	'0',	'1.009',	'0.848',	'-1.857',	'0.166',	'2.374',	'0',	'-1.526',	'0.849',	'0.677'];
                relative_pos_y = ['null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'null',	'-1.19',	'null',	'0',	'-5.02',	'0',	'5.02',	'null',	'-4.361',	'null',	'-0.42',	'0',	'1.268',	'0.849',	'-2.117',	'0',	'2.966',	'0.848',	'-3.814',	'0.123',	'4.417',	'0',	'-3.569',	'0.849',	'2.72',	'0',	'-1.871',	'0.848',	'1.023',	'0',	'-0.174',	'null',	'1.005',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-1.19',	'null',	'-5.02',	'0',	'5.02',	'0',	'-0.241',	'-0.42',	'-0.848',	'1.268',	'0',	'-2.117',	'-0.848',	'2.965',	'0',	'-3.814',	'-0.725',	'4.417',	'-0.849',	'-3.568',	'0',	'2.72',	'-0.849',	'-1.871',	'0',	'1.023',	'-0.849',	'-0.174',	'null',	'0',	'5.37',	'null',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'null',	'-1.19',	'null',	'0',	'-5.02',	'0',	'5.02',	'-0.241',	'-0.377',	'-0.848',	'1.225',	'0',	'-2.074',	'-0.848',	'2.922',	'0',	'-3.771',	'-0.769',	'4.46',	'-0.848',	'-3.612',	'0',	'2.763',	'-0.848',	'-1.915',	'0',	'1.066',	'-0.848',	'-0.218',	'null',	'5.371',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-1.19',	'null',	'-5.02',	'0',	'5.02',	'0',	'null',	'-4.78',	'null',	'0.462',	'0.849',	'-1.311',	'0',	'2.159',	'0.849',	'-3.008',	'0',	'3.856',	'0.684',	'-4.375',	'0.849',	'3.526',	'0',	'-2.678',	'0.849',	'1.829',	'0',	'-0.981',	'0.849',	'0.132',	'null',	'0',	'0.83',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-0.72',	'null',	'-3.828',	'null',	'-1.919',	'null',	'-0.214',	'null',	'0',	'null',	'5.961',	'null',	'0.12',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'null',	'-4.748',	'null',	'-1.933',	'null',	'-0.001',	'null',	'1.811',	'null',	'0',	'4.271',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-0.721',	'null',	'-4.627',	'-0.766',	'-0.567',	'null',	'-0.001',	'null',	'5.962',	'null',	'0.12',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'null',	'-4.748',	'null',	'-1.933',	'null',	'-0.001',	'null',	'0.992',	'null',	'0',	'5.09',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-0.721',	'null',	'-5.96',	'null',	'0',	'null',	'0.921',	'-0.389',	'5.428',	'null',	'0.121',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'null',	'-4.748',	'null',	'-1.933',	'null',	'-0.002',	'null',	'0.174',	'null',	'0',	'5.909',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-5.407',	'null',	'-1.274',	'null',	'0',	'null',	'5.96',	'0.001',	'-5.96',	'null',	'6.08',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'null',	'-4.748',	'null',	'-1.933',	'null',	'0',	'null',	'0.065',	'null',	'0',	'6.016',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-5.053',	'null',	'-1.628',	'0',	'5.961',	'null',	'-0.001',	'null',	'-5.959',	'null',	'6.08',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'null',	'-4.747',	'null',	'-1.934',	'null',	'0',	'null',	'0.284',	'null',	'0',	'5.797',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-4.699',	'null',	'-1.982',	'0',	'5.961',	'null',	'0',	'null',	'-5.961',	'null',	'6.081',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'-0.721',	'-1.854',	'null',	'-2.173',	'null',	'-1.933',	'null',	'0',	'null',	'0.505',	'null',	'0',	'5.576',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-5.213',	'null',	'-1.468',	'0',	'5.961',	'null',	'-0.001',	'null',	'-5.388',	'-0.101',	'5.02',	'0',	'-5.02',	'0',	'0.754',	'-0.514',	'0',	'1.363',	'0.848',	'-2.18',	'0.848',	'2.181',	'0.849',	'-2.181',	'0.848',	'1.963',	'0',	'-1.114',	'0.848',	'0.266',	'null',	'0.831',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'null',	'-6.681',	'null',	'0.724',	'null',	'-0.253',	'null',	'0',	'5.02',	'0',	'-5.02',	'0.906',	'-0.667',	'0.631',	'0.885',	'0.848',	'-0.884',	'0.848',	'0.885',	'0.849',	'-0.885',	'0.848',	'0.515',	'null',	'0',	'0.831',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-4.994',	'null',	'-1.597',	'null',	'-0.091',	'null',	'5.962',	'null',	'-0.001',	'null',	'-5.688',	'0.199',	'5.02',	'0',	'-5.02',	'0',	'null',	'1.048',	'null',	'-0.809',	'0',	'1.657',	'0.849',	'-2.506',	'0.674',	'2.68',	'0.849',	'-2.68',	'0.849',	'2.169',	'0',	'-1.321',	'0.849',	'0.472',	'null',	'0.83',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'null',	'-6.681',	'null',	'0.944',	'null',	'-0.473',	'null',	'0',	'5.02',	'0',	'-5.02',	'0.797',	'-0.559',	'0.223',	'1.184',	'0.849',	'-1.185',	'0.849',	'1.184',	'0.849',	'-1.184',	'0.848',	'0.924',	'null',	'0',	'0.831',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-4.774',	'null',	'-1.597',	'null',	'-0.311',	'null',	'5.961',	'null',	'-0.027',	'null',	'-5.932',	'0.47',	'5.02',	'0',	'-5.02',	'0',	'0.754',	'-0.514',	'0',	'1.363',	'0.848',	'-2.211',	'0',	'3.06',	'0.849',	'-3.181',	'0.848',	'2.963',	'0',	'-2.114',	'0.849',	'1.265',	'0',	'-0.417',	'null',	'1.248',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'null',	'-6.681',	'null',	'1.163',	'null',	'-0.692',	'null',	'0',	'5.02',	'0',	'-5.02',	'null',	'0.658',	'null',	'-0.419',	'0',	'1.267',	'0.849',	'-1.485',	'0.849',	'1.484',	'0.849',	'-1.485',	'0.849',	'1.363',	'0',	'-0.515',	'null',	'0',	'1.346',	'null',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-4.555',	'null',	'-1.597',	'null',	'-0.529',	'null',	'5.96',	'null',	'-0.327',	'null',	'-5.632',	'0.47',	'5.02',	'0',	'-5.02',	'0',	'null',	'0.351',	'null',	'-0.112',	'0',	'0.96',	'0.849',	'-1.809',	'0',	'2.657',	'0.849',	'-3.506',	'0.674',	'3.68',	'0.187',	'-3.018',	'0.849',	'2.169',	'0',	'-1.321',	'0.849',	'0.472',	'null',	'0.83',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'null',	'-6.681',	'null',	'1.383',	'null',	'4.474',	'null',	'0.102',	'null',	'-0.468',	'null',	'-5.02',	'0',	'5.02',	'0',	'-0.241',	'-0.675',	'-0.849',	'1.524',	'-0.588',	'-1.784',	'-0.849',	'1.784',	'-0.848',	'-1.784',	'-0.472',	'1.407',	'-0.848',	'-0.559',	'null',	'0',	'5.372',	'null',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'null',	'-0.722',	'null',	'-0.402',	'null',	'-3.955',	'null',	'-1.596',	'null',	'2.075',	'null',	'0',	'-2.2',	'0',	'2.2',	'0.6',	'0',	'-3.4',	'0',	'3.4',	'null',	'-0.6',	'null',	'-2.2',	'0',	'2.2',	'0',	'0.6',	'-3.4',	'0',	'3.4',	'0',	'null',	'3.4',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-0.72',	'null',	'-5.961',	'null',	'0.749',	'null',	'1.596',	'null',	'-2.344',	'null',	'5.332',	'null',	'0',	'0.748',	'null',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'-0.721',	'-0.633',	'null',	'-5.102',	'null',	'1.597',	'null',	'3.435',	'null',	'0.702',	'null',	'-3.878',	'null',	'0',	'-2.2',	'0',	'2.2',	'0.6',	'0',	'-3.4',	'0',	'3.4',	'null',	'-0.6',	'null',	'-2.2',	'0',	'2.2',	'0',	'0.6',	'-3.4',	'0',	'3.4',	'0',	'null',	'3.4',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-0.72',	'null',	'-5.962',	'null',	'0.002',	'null',	'5.032',	'null',	'-4.065',	'null',	'1.597',	'null',	'0',	'3.516',	'null',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'-0.721',	'-1.451',	'null',	'-4.064',	'null',	'1.596',	'null',	'2.917',	'null',	'1.001',	'null',	'-3.878',	'null',	'0',	'-2.2',	'0',	'2.2',	'0.6',	'0',	'-3.4',	'0',	'3.4',	'null',	'-1.19',	'null',	'0',	'-1.02',	'0',	'1.02',	'null',	'4.59',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-0.721',	'null',	'-5.961',	'null',	'0.002',	'null',	'4.732',	'null',	'-3.545',	'null',	'1.597',	'null',	'0',	'3.296',	'null',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'null',	'-0.721',	'null',	'-2.275',	'null',	'-3.02',	'null',	'1.597',	'null',	'2.394',	'null',	'1.303',	'null',	'-3.878',	'null',	'0',	'-2.2',	'0',	'2.2',	'0.6',	'0',	'-3.4',	'0',	'3.4',	'null',	'-1.19',	'null',	'0',	'-1.02',	'0',	'1.02',	'-0.646',	'0.406',	'-0.541',	'0.541',	'-0.541',	'0.541',	'-0.541',	'0.541',	'-0.541',	'0.541',	'-0.541',	'0.541',	'-0.541',	'0.541',	'-0.541',	'0.541',	'-0.541',	'0.541',	'-0.541',	'0.541',	'-0.541',	'0.54',	'-0.54',	'0.54',	'-0.54',	'0.54',	'-0.54',	'0.54',	'-0.54',	'0.54',	'-0.54',	'0.54',	'-0.54',	'0.54',	'-0.54',	'0.54',	'-0.54',	'0.54',	'-0.54',	'0.54',	'null',	'4.831',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-0.72',	'null',	'-5.962',	'0.002',	'4.431',	'null',	'-3.024',	'null',	'1.597',	'null',	'0',	'3.076',	'null',	'null',	'0',	'-6.2',	'0',	'6.2',	'0.6',	'0',	'-7.4',	'0',	'7.4',	'null',	'-1.19',	'null',	'0',	'-5.02',	'0',	'5.02',	'null',	'-4.361',	'null',	'-0.42',	'0',	'1.268',	'0.849',	'-2.117',	'0',	'2.966',	'0.848',	'-3.814',	'0.123',	'4.417',	'0',	'-3.569',	'0.849',	'2.72',	'0',	'-1.871',	'0.848',	'1.023',	'0',	'-0.174',	'null',	'-2.995',	'null',	'0',	'-2.2',	'0',	'2.2',	'0.6',	'0',	'-3.4',	'0',	'3.4',	'null',	'-1.19',	'null',	'0',	'-1.02',	'0',	'1.02',	'-0.575',	'-0.205',	'0.539',	'-0.539',	'0.539',	'-0.539',	'0.539',	'-0.539',	'0.539',	'-0.539',	'0.539',	'-0.539',	'0.539',	'-0.539',	'0.539',	'-0.539',	'0.539',	'-0.539',	'0.539',	'-0.539',	'0.539',	'-0.539',	'0.538',	'-0.538',	'0.538',	'-0.538',	'0.538',	'-0.538',	'0.538',	'-0.538',	'0.538',	'-0.538',	'0.538',	'-0.538',	'0.538',	'-0.538',	'0.538',	'-0.538',	'0.538',	'-0.538',	'null',	'5.37',	'null',	'-6.2',	'0',	'6.2',	'0',	'0.6',	'-7.4',	'0',	'7.4',	'0',	'null',	'-1.19',	'null',	'-5.02',	'0',	'5.02',	'0',	'-0.241',	'-0.42',	'-0.848',	'1.268',	'0',	'-2.117',	'-0.848',	'2.965',	'0',	'-3.814',	'-0.725',	'4.417',	'-0.849',	'-3.568',	'0',	'2.72',	'-0.849',	'-1.871',	'0',	'1.023',	'-0.849',	'-0.174',	'null',	'0',	'4.37',	'null',	'null',	'0',	'-4.2',	'0',	'4.2',	'0.6',	'0',	'-5.4',	'0',	'5.4',	'null',	'-1.19',	'null',	'0',	'-3.02',	'0',	'3.02',	'-0.241',	'-0.922',	'-0.849',	'1.771',	'-0.08',	'-2.46',	'0',	'1.612',	'-0.849',	'-0.763',	'null',	'3.371',	'null',	'-4.2',	'0',	'4.2',	'0',	'0.6',	'-5.4',	'0',	'5.4',	'0',	'null',	'-1.19',	'null',	'-3.02',	'0',	'3.02',	'0',	'null',	'-2.781',	'null',	'0.16',	'0.849',	'-1.009',	'0',	'1.857',	'0.683',	'-2.374',	'0.848',	'1.526',	'0',	'-0.677',	'null',	'0',	'1.508',	'null',	'null',	'0',	'-4.2',	'0',	'4.2',	'0.6',	'0',	'-5.4',	'0',	'5.4',	'null',	'-1.19',	'null',	'0',	'-3.02',	'0',	'3.02',	'null',	'-2.664',	'null',	'-0.117',	'0',	'0.966',	'0.848',	'-1.814',	'0.123',	'2.417',	'0',	'-1.569',	'0.849',	'0.72',	'null',	'0.831',	'null',	'-4.2',	'0',	'4.2',	'0',	'0.6',	'-5.4',	'0',	'5.4',	'0',	'null',	'-1.19',	'null',	'-3.02',	'0',	'3.02',	'0',	'-0.241',	'-0.117',	'-0.849',	'0.966',	'0',	'-1.814',	'-0.726',	'2.417',	'-0.848',	'-1.569',	'0',	'0.72',	'null',	'0',	'2.651',	'null',	'null',	'0',	'-4.2',	'0',	'4.2',	'0.6',	'0',	'-5.4',	'0',	'5.4',	'null',	'-1.19',	'null',	'0',	'-3.02',	'0',	'3.02',	'-0.241',	'-0.922',	'-0.849',	'1.771',	'-0.08',	'-2.46',	'0',	'1.612',	'-0.849',	'-0.763',	'null',	'3.371',	'null',	'-4.2',	'0',	'4.2',	'0',	'0.6',	'-5.4',	'0',	'5.4',	'0',	'null',	'-1.19',	'null',	'-3.02',	'0',	'3.02',	'0',	'null',	'-2.781',	'null',	'0.16',	'0.849',	'-1.009',	'0',	'1.857',	'0.683',	'-2.374',	'0.848',	'1.526',	'0',	'-0.677'];
                relative_pos_z = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.3',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
            }
            if (nozzle_size === 0.8) {
                GStatus = ['null',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G0',	'null',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G1',	'G1',	'G1',	'G1',	'G0',	'G1',	'G1',	'G0',	'G1'];
                EStatus = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'retract',	'null',	'null',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null',	'null',	'retract',	'null',	'extrude',	'null',	'null',	'null'];
                layerStatus = ['LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'LAYER',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
                relative_pos_x = ['null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-1.59',	'null',	'-4.02',	'0',	'4.02',	'0',	'null',	'-0.32',	'null',	'-0.958',	'-1.131',	'2.089',	'0',	'-3.22',	'-0.16',	'2.408',	'-1.131',	'-1.277',	'0',	'0.145',	'null',	'30.745',	'null',	'0',	'5.6',	'0',	'-5.6',	'-0.8',	'0',	'7.2',	'0',	'-7.2',	'null',	'1.59',	'null',	'0',	'4.02',	'0',	'-4.02',	'1.276',	'-0.958',	'0',	'2.089',	'1.132',	'-3.221',	'0.972',	'2.408',	'0',	'-1.277',	'1.132',	'0.145',	'null',	'0',	'-30.888',	'null',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-1.59',	'null',	'-4.02',	'0',	'4.02',	'0',	'-0.951',	'0.631',	'0',	'-1.762',	'-1.132',	'2.894',	'-0.645',	'-2.735',	'0',	'1.603',	'-1.131',	'-0.472',	'null',	'30.89',	'null',	'0',	'5.6',	'0',	'-5.6',	'-0.8',	'0',	'7.2',	'0',	'-7.2',	'null',	'1.59',	'null',	'0',	'4.02',	'0',	'-4.02',	'null',	'0.47',	'null',	'-0.152',	'0',	'1.283',	'1.132',	'-2.415',	'0.166',	'3.214',	'0',	'-2.083',	'1.132',	'0.951',	'null',	'0',	'-5.144',	'null',	'null',	'0',	'6.256',	'0',	'-6.256',	'-0.8',	'0',	'7.856',	'0',	'-7.856',	'null',	'1.59',	'null',	'0',	'4.676',	'0',	'-4.676',	'0.8',	'-0.482',	'0',	'1.614',	'1.131',	'-2.745',	'0.497',	'3.38',	'0.159',	'-2.408',	'1.131',	'1.277',	'0',	'-0.145',	'null',	'-30.349',	'null',	'-5.994',	'0',	'5.994',	'0',	'0.8',	'-7.594',	'0',	'7.594',	'0',	'null',	'-1.59',	'null',	'-4.414',	'0',	'4.414',	'0',	'null',	'-0.32',	'null',	'-0.22',	'-1.132',	'1.352',	'0',	'-2.483',	'-1.131',	'3.38',	'-1.132',	'-2.408',	'0',	'1.277',	'-1.132',	'-0.145',	'null',	'0',	'29.567',	'null',	'null',	'0',	'6.923',	'0',	'-6.923',	'-0.8',	'0',	'8.523',	'0',	'-8.523',	'null',	'1.59',	'null',	'0',	'5.343',	'0',	'-5.343',	'null',	'0.661',	'null',	'-0.342',	'0',	'1.474',	'1.131',	'-2.605',	'0.357',	'3.38',	'0.965',	'-3.214',	'1.131',	'2.083',	'0',	'-0.951',	'null',	'-29.143',	'null',	'-6.394',	'0',	'6.394',	'0',	'0.8',	'-7.994',	'0',	'7.994',	'0',	'null',	'-1.59',	'null',	'-4.814',	'0',	'4.814',	'0',	'-0.614',	'0.293',	'0',	'-1.424',	'-1.131',	'2.555',	'-0.307',	'-3.38',	'-0.486',	'2.735',	'-1.132',	'-1.603',	'0',	'0.472',	'null',	'0',	'28.428',	'null',	'null',	'0',	'7.59',	'0',	'-7.59',	'-0.8',	'0',	'9.19',	'0',	'-9.19',	'null',	'0.959',	'null',	'0.297',	'-0.297',	'3.947',	'1.014',	'2.309',	'null',	'-30.645',	'null',	'-6.794',	'0',	'6.794',	'0',	'0.8',	'-8.394',	'0',	'8.394',	'0',	'-1.126',	'-5.28',	'null',	'4.431',	'null',	'-1.414',	'null',	'0',	'25.139',	'null',	'null',	'0',	'8.256',	'0',	'-8.256',	'-0.8',	'0',	'9.856',	'0',	'-9.856',	'null',	'3.616',	'null',	'3.049',	'0.321',	'1.909',	'null',	'-5.429',	'null',	'0',	'-1.876',	'0',	'1.876',	'-1.013',	'-0.544',	'0',	'1.236',	'0',	'-1.236',	'0.558',	'0.678',	'null',	'-24.495',	'null',	'-7.194',	'0',	'7.194',	'0',	'0.8',	'-8.794',	'0',	'8.794',	'0',	'-1.126',	'-5.28',	'null',	'3.738',	'null',	'-1.414',	'null',	'0',	'24.765',	'null',	'null',	'0',	'8.923',	'0',	'-8.923',	'-0.8',	'0',	'10.523',	'0',	'-10.523',	'null',	'4.282',	'null',	'4.14',	'-0.37',	'1.51',	'null',	'-5.429',	'null',	'0',	'-2.543',	'0',	'2.543',	'-0.321',	'-1.002',	'-0.901',	'1.903',	'0',	'-1.903',	'0',	'0.886',	'null',	'-23.078',	'null',	'-7.594',	'0',	'7.594',	'0',	'0.8',	'-9.194',	'0',	'9.194',	'0',	'-1.127',	'-5.28',	'null',	'3.048',	'null',	'-1.416',	'null',	'0',	'24.391',	'null',	'null',	'0',	'9.59',	'0',	'-9.59',	'-0.8',	'0',	'11.19',	'0',	'-11.19',	'null',	'4.95',	'null',	'5.233',	'-1.064',	'1.11',	'null',	'-5.429',	'null',	'0',	'-3.21',	'0',	'3.21',	'null',	'-2.891',	'null',	'0.747',	'1.131',	'-1.878',	'0',	'2.57',	'0',	'-1.809',	'1.131',	'0.678',	'null',	'-23.695',	'null',	'-7.994',	'0',	'7.994',	'0',	'0.8',	'-9.594',	'0',	'9.594',	'0',	'null',	'-3.355',	'null',	'-3.052',	'null',	'2.355',	'null',	'-1.415',	'null',	'2.263',	'null',	'0',	'1.614',	'0',	'-1.614',	'0.532',	'0.762',	'-0.974',	'0.974',	'-0.974',	'0.974',	'-0.776',	'-0.198',	'null',	'0',	'21.434',	'null',	'null',	'0',	'10.256',	'0',	'-10.256',	'-0.8',	'0',	'11.856',	'0',	'-11.856',	'null',	'6.616',	'null',	'4.279',	'0',	'-0.709',	'null',	'-3.72',	'null',	'0',	'-4.876',	'0',	'4.876',	'-0.322',	'-0.871',	'-1.131',	'2.002',	'0',	'-3.133',	'-1.102',	'3.35',	'-1.131',	'-2.219',	'0',	'1.087',	'null',	'-21.146',	'null',	'-8.394',	'0',	'8.394',	'0',	'0.8',	'-9.994',	'0',	'9.994',	'0',	'null',	'-4.754',	'null',	'-1.653',	'null',	'1.651',	'null',	'-1.404',	'null',	'1.556',	'null',	'-0.001',	'3.015',	'0',	'-3.014',	'1.191',	'-0.872',	'-0.001',	'2.004',	'0.371',	'-2.375',	'0.888',	'1.487',	'0',	'-0.356',	'null',	'0',	'-1.327',	'null',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-3.659',	'null',	'1.415',	'-0.968',	'2.251',	'null',	'3.961',	'null',	'-1.2',	'0',	'1.2',	'0',	'-0.594',	'-0.007',	'-0.125',	'null',	'17.526',	'null',	'0',	'1.2',	'0',	'-1.2',	'0.655',	'-0.057',	'-0.073',	'null',	'5.275',	'null',	'0',	'5.6',	'0',	'-5.6',	'-0.8',	'0',	'7.2',	'0',	'-7.2',	'null',	'0.96',	'null',	'5.279',	'0',	'-0.309',	'null',	'0',	'-31.53',	'null',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-3.952',	'null',	'1.415',	'-0.275',	'1.851',	'null',	'21.161',	'null',	'-17.6',	'0',	'17.6',	'0',	'0.8',	'-19.2',	'0',	'19.2',	'0',	'null',	'-1.59',	'null',	'-16.02',	'0',	'16.02',	'0',	'null',	'6.19',	'null',	'0',	'5.6',	'0',	'-5.6',	'-0.8',	'0',	'7.2',	'0',	'-7.2',	'null',	'0.96',	'null',	'5.278',	'null',	'0',	'-31.838',	'null',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-1.59',	'null',	'-4.02',	'0',	'4.02',	'0',	'-0.951',	'0.631',	'0',	'-1.762',	'-1.132',	'2.894',	'-0.645',	'-2.735',	'0',	'1.603',	'-1.131',	'-0.472',	'null',	'25.49',	'null',	'-17.6',	'0',	'17.6',	'0',	'0.8',	'-19.2',	'0',	'19.2',	'0',	'null',	'-1.59',	'null',	'-16.02',	'0',	'16.02',	'0',	'null',	'6.19',	'null',	'0',	'5.6',	'0',	'-5.6',	'-0.8',	'0',	'7.2',	'0',	'-7.2',	'null',	'1.59',	'null',	'0',	'4.02',	'0',	'-4.02',	'null',	'0.47',	'null',	'-0.152',	'0',	'1.283',	'1.132',	'-2.415',	'0.166',	'3.214',	'0',	'-2.083',	'1.132',	'0.951',	'null',	'0',	'-3.488',	'null',	'null',	'0',	'0',	'3.599',	'0.001',	'-3.201',	'-0.399',	'-0.8',	'0',	'5.199',	'0.001',	'-5.2',	'null',	'1.59',	'null',	'0',	'2.019',	'0.001',	'-2.02',	'null',	'1.537',	'null',	'-1.219',	'0.973',	'0.408',	'null',	'-30.889',	'null',	'-3.201',	'-0.399',	'0',	'0',	'3.599',	'0.001',	'0.8',	'-5.2',	'0',	'5.199',	'0.001',	'null',	'-1.59',	'null',	'-2.02',	'0',	'2.019',	'0.001',	'-0.321',	'-1.22',	'-0.159',	'0.408',	'null',	'0',	'2.082',	'null',	'null',	'-3.6',	'0',	'3.6',	'0',	'0.8',	'-5.2',	'0',	'5.2',	'0',	'null',	'-1.59',	'null',	'-2.02',	'0',	'2.02',	'0',	'-1.214',	'0.894',	'-0.645',	'-0.735',	'null',	'30.89',	'null',	'0',	'3.6',	'0',	'-3.6',	'-0.8',	'0',	'5.2',	'0',	'-5.2',	'null',	'1.59',	'null',	'0',	'2.02',	'0',	'-2.02',	'null',	'0.733',	'null',	'-0.415',	'0.166',	'1.215',	'null',	'0',	'-30.889',	'null',	'null',	'-3.6',	'0',	'3.6',	'0',	'0.8',	'-5.2',	'0',	'5.2',	'0',	'null',	'-1.59',	'null',	'-2.02',	'0',	'2.02',	'0',	'-0.32',	'-1.221',	'-0.159',	'0.408',	'null',	'30.482',	'null',	'0',	'3.6',	'0',	'-3.6',	'-0.8',	'0',	'5.2',	'0',	'-5.2',	'null',	'1.59',	'null',	'0',	'2.02',	'0',	'-2.02',	'null',	'1.539',	'null',	'-1.221',	'0.972',	'0.409'];
                relative_pos_y = ['null',	'0',	'-5.6',	'0',	'5.6',	'0.8',	'0',	'-7.2',	'0',	'7.2',	'null',	'-1.59',	'null',	'0',	'-4.02',	'0',	'4.02',	'null',	'-2.744',	'null',	'-0.957',	'0',	'2.089',	'1.131',	'-3.22',	'0.971',	'2.409',	'0',	'-1.277',	'1.131',	'0.146',	'null',	'1.111',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-1.59',	'null',	'-4.02',	'0',	'4.02',	'0',	'-0.321',	'-0.957',	'-1.131',	'2.088',	'0',	'-3.22',	'-0.16',	'2.409',	'-1.132',	'-1.277',	'0',	'0.146',	'null',	'0',	'4.345',	'null',	'null',	'0',	'-5.6',	'0',	'5.6',	'0.8',	'0',	'-7.2',	'0',	'7.2',	'null',	'-1.59',	'null',	'0',	'-4.02',	'0',	'4.02',	'-0.321',	'-0.631',	'-1.131',	'1.762',	'0',	'-2.894',	'-0.486',	'2.735',	'-1.132',	'-1.603',	'0',	'0.472',	'null',	'4.019',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-1.59',	'null',	'-4.02',	'0',	'4.02',	'0',	'null',	'-3.701',	'null',	'0.152',	'1.131',	'-1.283',	'0',	'2.415',	'0.965',	'-3.214',	'1.131',	'2.083',	'0',	'-0.951',	'null',	'0',	'2.062',	'null',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-1.59',	'null',	'-4.02',	'0',	'4.02',	'0',	'-0.321',	'-0.482',	'-1.131',	'1.613',	'0',	'-2.745',	'-0.635',	'3.38',	'-0.971',	'-2.409',	'0',	'1.277',	'-1.131',	'-0.146',	'null',	'4.491',	'null',	'0',	'-5.6',	'0',	'5.6',	'0.8',	'0',	'-7.2',	'0',	'7.2',	'null',	'-1.59',	'null',	'0',	'-4.02',	'0',	'4.02',	'null',	'-3.481',	'null',	'-0.22',	'0',	'1.351',	'1.131',	'-2.482',	'0',	'3.38',	'0',	'-2.409',	'1.132',	'1.277',	'0',	'-0.146',	'null',	'0',	'1.257',	'null',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-1.59',	'null',	'-4.02',	'0',	'4.02',	'0',	'null',	'-3.701',	'null',	'0.343',	'1.131',	'-1.474',	'0',	'2.605',	'0.775',	'-3.38',	'0.166',	'3.214',	'0',	'-2.083',	'1.132',	'0.951',	'null',	'1.111',	'null',	'0',	'-5.6',	'0',	'5.6',	'0.8',	'0',	'-7.2',	'0',	'7.2',	'null',	'-1.59',	'null',	'0',	'-4.02',	'0',	'4.02',	'-0.321',	'-0.293',	'-1.131',	'1.424',	'0',	'-2.556',	'-0.824',	'3.38',	'-0.645',	'-2.735',	'0',	'1.603',	'-1.131',	'-0.472',	'null',	'0',	'4.491',	'null',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-5.133',	'null',	'-1.108',	'1.057',	'-1.057',	'0.001',	'2.309',	'null',	'3.131',	'null',	'0',	'-5.6',	'0',	'5.6',	'0.8',	'0',	'-7.2',	'0',	'7.2',	'-0.961',	'-5.281',	'null',	'0',	'null',	'5.281',	'null',	'0',	'0.161',	'null',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-5.424',	'null',	'-0.817',	'0.001',	'1.908',	'null',	'-1.278',	'null',	'4.02',	'0',	'-4.02',	'0',	'0.319',	'0.545',	'1.131',	'-1.236',	'1.132',	'1.236',	'0.572',	'-0.677',	'null',	'1.788',	'null',	'0',	'-5.6',	'0',	'5.6',	'0.8',	'0',	'-7.2',	'0',	'7.2',	'-0.961',	'-5.28',	'null',	'-0.001',	'null',	'5.281',	'null',	'0',	'0.161',	'null',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-5.132',	'null',	'-1.109',	'0.001',	'1.509',	'null',	'-0.879',	'null',	'4.02',	'0',	'-4.02',	'0',	'1.322',	'-1.002',	'0.231',	'1.902',	'1.132',	'-1.903',	'1.131',	'0.886',	'null',	'1.111',	'null',	'0',	'-5.6',	'0',	'5.6',	'0.8',	'0',	'-7.2',	'0',	'7.2',	'-0.962',	'-5.279',	'null',	'-0.001',	'null',	'5.282',	'null',	'0',	'0.16',	'null',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-4.839',	'null',	'-1.402',	'0.001',	'1.109',	'null',	'-0.479',	'null',	'4.02',	'0',	'-4.02',	'0',	'null',	'1.066',	'null',	'-0.747',	'0',	'1.879',	'1.131',	'-2.57',	'1.132',	'1.808',	'0',	'-0.677',	'null',	'1.788',	'null',	'0',	'-5.6',	'0',	'5.6',	'0.8',	'0',	'-7.2',	'0',	'7.2',	'null',	'-3.189',	'null',	'-3.052',	'null',	'-0.001',	'null',	'5.281',	'null',	'-0.629',	'null',	'-4.02',	'0',	'4.02',	'0',	'-0.321',	'-0.763',	'-0.157',	'-0.974',	'-0.157',	'-0.974',	'-0.355',	'0.198',	'null',	'0',	'4.293',	'null',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-4.814',	'null',	'-1.147',	'0.43',	'-0.709',	'null',	'0.63',	'null',	'4.02',	'0',	'-4.02',	'0',	'1.191',	'-0.872',	'0',	'2.003',	'1.131',	'-3.134',	'0.03',	'3.35',	'0',	'-2.218',	'1.131',	'1.087',	'null',	'1.111',	'null',	'0',	'-5.6',	'0',	'5.6',	'0.8',	'0',	'-7.2',	'0',	'7.2',	'null',	'-4.589',	'null',	'-1.653',	'null',	'0.04',	'null',	'5.241',	'null',	'-0.629',	'null',	'-4.02',	'0',	'4.02',	'0',	'-0.321',	'-0.872',	'-1.132',	'2.004',	'-0.76',	'-2.376',	'-0.244',	'1.488',	'-1.131',	'-0.357',	'null',	'0',	'4.491',	'null',	'null',	'0',	'-5.6',	'0',	'5.6',	'0.8',	'0',	'-7.2',	'0',	'7.2',	'null',	'-0.961',	'null',	'-5.281',	'0.001',	'2.252',	'null',	'-0.011',	'null',	'0',	'-3.2',	'0',	'3.2',	'-0.596',	'-0.559',	'-1.572',	'null',	'2.727',	'null',	'-3.2',	'0',	'3.2',	'0',	'-0.543',	'-0.509',	'-1.623',	'null',	'5.875',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-4.253',	'null',	'-1.415',	'-0.263',	'-0.309',	'null',	'0',	'5.44',	'null',	'null',	'0',	'-5.6',	'0',	'5.6',	'0.8',	'0',	'-7.2',	'0',	'7.2',	'null',	'-0.961',	'null',	'-5.281',	'0.001',	'1.851',	'null',	'-0.41',	'null',	'0',	'-1.6',	'0',	'1.6',	'0.8',	'0',	'-3.2',	'0',	'3.2',	'null',	'-1.59',	'null',	'0',	'-0.02',	'0',	'0.02',	'null',	'4.79',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-3.96',	'null',	'-1.415',	'null',	'0',	'4.575',	'null',	'null',	'0',	'-5.6',	'0',	'5.6',	'0.8',	'0',	'-7.2',	'0',	'7.2',	'null',	'-1.59',	'null',	'0',	'-4.02',	'0',	'4.02',	'-0.321',	'-0.631',	'-1.131',	'1.762',	'0',	'-2.894',	'-0.486',	'2.735',	'-1.132',	'-1.603',	'0',	'0.472',	'null',	'0.019',	'null',	'0',	'-1.6',	'0',	'1.6',	'0.8',	'0',	'-3.2',	'0',	'3.2',	'null',	'-1.59',	'null',	'0',	'-0.02',	'0',	'0.02',	'null',	'4.79',	'null',	'-5.6',	'0',	'5.6',	'0',	'0.8',	'-7.2',	'0',	'7.2',	'0',	'null',	'-1.59',	'null',	'-4.02',	'0',	'4.02',	'0',	'null',	'-3.701',	'null',	'0.152',	'1.131',	'-1.283',	'0',	'2.415',	'0.965',	'-3.214',	'1.131',	'2.083',	'0',	'-0.951',	'null',	'0',	'1.062',	'null',	'null',	'-0.399',	'-3.201',	'0',	'3.599',	'0.001',	'0',	'0.8',	'-5.2',	'0',	'5.199',	'0.001',	'null',	'-1.59',	'null',	'-2.02',	'0',	'2.019',	'0.001',	'null',	'-0.322',	'null',	'-1.219',	'-0.159',	'0.408',	'null',	'2.081',	'null',	'0.001',	'0',	'-0.399',	'-3.201',	'0',	'3.599',	'0.8',	'0.001',	'-5.2',	'0',	'5.199',	'null',	'-1.59',	'null',	'0.001',	'-2.02',	'0',	'2.019',	'-0.481',	'-1.219',	'0.971',	'0.408',	'null',	'0',	'1.112',	'null',	'null',	'0',	'-3.6',	'0',	'3.6',	'0.8',	'0',	'-5.2',	'0',	'5.2',	'null',	'-1.59',	'null',	'0',	'-2.02',	'0',	'2.02',	'-0.321',	'-0.894',	'-0.486',	'0.735',	'null',	'1.756',	'null',	'-3.6',	'0',	'3.6',	'0',	'0.8',	'-5.2',	'0',	'5.2',	'0',	'null',	'-1.59',	'null',	'-2.02',	'0',	'2.02',	'0',	'null',	'-1.701',	'null',	'0.415',	'0.966',	'-1.215',	'null',	'0',	'2.325',	'null',	'null',	'0',	'-3.6',	'0',	'3.6',	'0.8',	'0',	'-5.2',	'0',	'5.2',	'null',	'-1.59',	'null',	'0',	'-2.02',	'0',	'2.02',	'-0.481',	'-1.22',	'0.971',	'0.409',	'null',	'1.111',	'null',	'-3.6',	'0',	'3.6',	'0',	'0.8',	'-5.2',	'0',	'5.2',	'0',	'null',	'-1.59',	'null',	'-2.02',	'0',	'2.02',	'0',	'null',	'-0.32',	'null',	'-1.221',	'-0.16',	'0.409'];
                relative_pos_z = ['null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'0.4',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null',	'null'];
            }
        }
    }

    OCTOPRINT_VIEWMODELS.push({
        construct: calibrationcompanionViewModel_temp,
        dependencies: [  "settingsViewModel", "calibrationcompanionViewModel"  ],
        elements: [ "#settings_plugin_calibrationcompanion", "#temperature" ]
    });
});
